/********************************************************************************
  * @file    PT32x076_ldac.h
  * @author  ӦÿŶ
  * @version V1.0.0
  * @date    2023/7/15
  * @brief   This file contains all the functions prototypes for the LDAC firmware
  *          library
  * @attention
  *
  * ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣
  * ̼/ͻʹаıϢκ, * Pai-IC κֱӣӻ̷𺦸
  *
  * (C) Ȩ Pai-IC Microelectronics
  *******************************************************************************/

/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef PT32x076_LDAC_H
#define PT32x076_LDAC_H

#ifdef __cplusplus
extern "C" {
#endif

/* Includes ------------------------------------------------------------------*/
#include "PT32x076.h"


/** @addtogroup LDAC
  * @{
  */

/* Exported types ------------------------------------------------------------*/
/* Exported constants --------------------------------------------------------*/

/** @defgroup IS_LDAC_ALL_PERIPH
  * @{
  */
#define IS_LDAC_ALL_PERIPH(SEL)            ((SEL) == LDAC)
/**
  * @}
  */

/** @defgroup IS_LDAC_Value
  * @{
  */
#define IS_LDAC_Value(SEL)       				  ((SEL) <= 0x7F)
/**
  * @}
  */

/* Exported macro ------------------------------------------------------------*/
/* Exported functions ------------------------------------------------------- */
void LDAC_SetData(LDAC_TypeDef *LDACx, u8 LDAC_Data);
void LDAC_Cmd(LDAC_TypeDef *LDACx, FunctionalState NewState);
void LDAC_OutputConfig(LDAC_TypeDef *LDACx, FunctionalState NewState);
/**
  * @}
  */

#ifdef __cplusplus
}
#endif

#endif /*__PT32x076_LDAC_H */
