/********************************************************************************
  * @file    PT32x076_opa.h
  * @author  ӦÿŶ
  * @version V1.0.0
  * @date    2023/7/15
  * @brief   This file contains all the functions prototypes for the OPA firmware
  *          library
  * @attention
  *
  * ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣
  * ̼/ͻʹаıϢκ, * Pai-IC κֱӣӻ̷𺦸
  *
  * (C) Ȩ Pai-IC Microelectronics
  *******************************************************************************/

#ifndef PT32x076_OPA_H
#define PT32x076_OPA_H

#ifdef __cplusplus
extern "C" {
#endif

#include "PT32x076.h"

/** @defgroup OPA_Number
* @{
*/
#define OPA0   			0
#define OPA1   			1
#define OPA2   			2
#define OPA3   			3

#define IS_OPA_Number(SEL)               (((SEL) == OPA0) || ((SEL) == OPA1) ||\
																					((SEL) == OPA2) || ((SEL) == OPA3))


/** @defgroup OPA_TrimValue
* @{
*/
#define IS_OPA_TrimValue(Value)       ((Value)<=0x7F)

/** @defgroup OPA_TrimKey
* @{
*/
#define OPA_TrimKey 0xAE0000
#define IS_OPA_TrimKey(SEL)     ((SEL)==OPA_TrimKey)


/*! function declaration and definition*/
void OPA_Cmd(u32 OPA_Num, FunctionalState NewState);
void OPA_TrimConfig(u32 OPA_Num, u32 Value);
void OPA_TrimModeCmd(u32 OPA_Num, FunctionalState NewState);
void OPA_TrimKeyConfig(u32 OPA_Num, u32 SEL);
#ifdef __cplusplus
}
#endif

#endif /*__PT32x076_OPA_H */
