  /******************************************************************************
  * @file    PT32x076_retarget.c
  * @author  ӦÿŶ
  * @version V1.0.0
  * @date    2023/7/15
  * @brief   ļӳfputc()fgetc()ֱ֧׼C/C++printfscanf
  *            
  ******************************************************************************
  * @attention
  *
	* ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣
  * ̼/ͻʹаıϢκ, * Pai-IC κֱӣ ӻ̷𺦸
  *
  * (C) Ȩ Pai-IC Microelectronics
  *****************************************************************************/
  
/* Includes ------------------------------------------------------------------------------------------------*/
#include "PT32x076.h"

#if defined (__CC_ARM)
	#pragma import(__use_no_semihosting_swi)
#endif

#include <stdio.h>

#if defined (__CC_ARM)
	#include <rt_misc.h>
#endif
 

/* Global variables ----------------------------------------------------------------------------------------*/
/** @defgroup RETARGET_Global_Variable Retarget global variables
  * @{
  */
#if defined (__CC_ARM)
struct __FILE
{
	int handle; /* Add whatever you need here */
};
FILE __stdout;
FILE __stdin;
#endif
/**
  * @}
  */

/* Global functions ----------------------------------------------------------------------------------------*/
/** @defgroup RETARGET_Exported_Functions Retarget exported functions
  * @{
  */

u8 SERIAL_PutChar(u8 ch);
u8 SERIAL_GetChar(void);

int __backspace(FILE *stream)
{
	return 0;
}

int fputc (int ch, FILE *f)
{
	return (SERIAL_PutChar(ch));
}

int fgetc (FILE *f)
{
	return (SERIAL_GetChar());
}

void _sys_exit(int return_code)
{
label:
	goto label;  /* endless loop */
}

/*********************************************************************************************************//**
 * @brief  Put char to UART.
 * @param  ch: The char put to UART.
 * @retval The char put to UART.
 ************************************************************************************************************/
u8 SERIAL_PutChar(u8 ch)
{
	while(UART_GetFlagStatus(UART0,UART_FLAG_TXF));
	UART0->DR = ch;
	return ch;
}

/*********************************************************************************************************//**
 * @brief  Get char from UART.
 * @retval The char got from UART.
 ************************************************************************************************************/
u8 SERIAL_GetChar(void)
{
	while ((UART0->SR & UART_FLAG_RXNE) == 0); // Wait if Receive Holding register is empty
	return (UART0->DR);
}
/**
  * @}
  */
