/******************************************************************************
  * @Example PT32x076_TIM
  * @author  ӦÿŶ
  * @version V1.0.0
  * @date    2023/7/15
  * @brief   ͨʱʱжϣÿ1s˸LED
  *          
  ******************************************************************************
  * @attention	Ϊ96001λֹͣλżУ
  *
	* ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣
  * ̼/ͻʹаıϢκ, * Pai-IC κֱӣ ӻ̷𺦸
  *
  * (C) Ȩ Pai-IC Microelectronics
  *
  *****************************************************************************/
	
#include "PT32x076.h"

#define		LED_PROT_RED		GPIOC
#define		LED_PIN_RED	    GPIO_Pin_12

#define		LED_RED_OFF()	GPIO_SetBits(LED_PROT_RED, LED_PIN_RED)
#define		LED_RED_ON()	GPIO_ResetBits(LED_PROT_RED, LED_PIN_RED)

/**
* @brief LED
* @param 
* @retval 
*/
void LED_Driver(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;				//һGPIO_InitTypeDef͵Ľṹ
	GPIO_InitStructure.GPIO_Pin = LED_PIN_RED;			//ѡҪƵGPIO
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OutPP;		//ģʽΪͨ
	GPIO_InitStructure.GPIO_Pull = GPIO_Pull_Up;	//
	GPIO_Init(LED_PROT_RED, &GPIO_InitStructure);				//ÿ⺯ʼGPIO
		
  GPIO_SetBits(LED_PROT_RED, LED_PIN_RED);					//GPIO״̬
}

/**
* @brief TIM2ʽ
* @param 
* @retval 
*/
void TIM2_Int_Diver(void)
{
	NVIC_InitTypeDef NVIC_InitStruct;								//һNVIC_InitTypeDef͵Ľṹ
	TIM_TimeBaseInitTypeDef  TIM_TimeBaseInitStruct;//һNVIC_InitTypeDef͵Ľṹ
	
	TIM_TimeBaseInitStruct.TIM_Prescaler = 3200-1;										 //32M/3200=0.01MHZ
	TIM_TimeBaseInitStruct.TIM_AutoReloadValue = 10000;								 //0.01MHZ*10000=1HZ
	TIM_TimeBaseInitStruct.TIM_Direction = TIM_Direction_Up;					 //ϼ
	TIM_TimeBaseInit(TIM2, &TIM_TimeBaseInitStruct);									 //ʼTIM2
	
	TIM_OCITConfig(TIM2,TIM_OCIT_ARI,ENABLE);									//ʱжϳʼ
	
	NVIC_InitStruct.NVIC_IRQChannel=TIM2_IRQn;								//ʱжԴ
	NVIC_InitStruct.NVIC_IRQChannelPriority=0x00;							//жȼ
	NVIC_InitStruct.NVIC_IRQChannelCmd=ENABLE;								//ʹNVIC
	NVIC_Init(&NVIC_InitStruct);															//ʼNVIC	
	
	TIM_Cmd(TIM2, ENABLE);																		//TIM2
}

u8 TIM_IT_FLAG=0;
int main (void)
{
	LED_Driver();
  TIM2_Int_Diver();
  while(1)
	{
		if(TIM_IT_FLAG)	//ȡжϱ־Ƿ
		{
			LED_RED_OFF();
		}
		else
		{
			LED_RED_ON();
		} 
	}
}
#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(u8* file, u32 line)
{
	/* User can add his own implementation to report the file name and line number,
	   ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
	printf("Wrong parameters value: file %s on line %d\r\n", file, line);
	/* Infinite loop */
	while (1)
	{
	}
}
#endif
