/******************************************************************************
  * @Example PT32x076_TIM
  * @author  ӦÿŶ
  * @version V1.0.0
  * @date    2023/7/15
  * @brief   ͨPA10ΪTIM1CH3PWMͨPWMʵְLEDɫƵЧ
  *          
  ******************************************************************************
  * @attention	Ϊ96001λֹͣλżУ
  *
	* ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣
  * ̼/ͻʹаıϢκ, * Pai-IC κֱӣ ӻ̷𺦸
  *
  * (C) Ȩ Pai-IC Microelectronics
  *
  *****************************************************************************/
	
#include "PT32x076.h"

/**
* @brief ʱ
* @param 
* @retval 
*/
void Software_Delay(void)
{
	u8 i, j;
	for(i=0; i<200; i++)
		for(j=0; j<50; j++);
}

/**
* @brief øTIM1Ƚͨ3
* @param 
* @retval 
*/
void TIM1_PWM_GPIO_Config(void)
{
	GPIO_DigitalRemapConfig(AFIOA, GPIO_Pin_10, AFIO_AF_4, ENABLE);
}

/**
* @brief TIM1ʽ
* @param 
* @retval 
*/
void TIM1_PWM_Mode_Config(void)
{
	TIM_TimeBaseInitTypeDef  TIM_TimeBaseInitStruct;//һTIM_TimeBaseInitTypeDef͵Ľṹ
	TIM_OCInitTypeDef TIM_OCInitStruct;//һTIM_OCInitTypeDeff͵Ľṹ
	
	TIM_TimeBaseInitStruct.TIM_Prescaler = 32-1;										   //32M/3200=0.01MHZ
	TIM_TimeBaseInitStruct.TIM_AutoReloadValue = 1000-1;						   //0.01MHZ*10000=1HZ
	TIM_TimeBaseInitStruct.TIM_Direction = TIM_Direction_Up;					 //ϼ
	TIM_TimeBaseInitStruct.TIM_CenterAlignedMode = TIM_CenterAlignedMode_Disable; //ļģʽ
	TIM_TimeBaseInitStruct.TIM_InternalClockSource = TIM_LIST4_InternalClockSource_PCLK;
	TIM_TimeBaseInit(TIM1, &TIM_TimeBaseInitStruct);									 //ʼTIM2
	
	TIM_OCInitStruct.TIM_Channel = TIM_Channel_3;
	TIM_OCInitStruct.TIM_OCMode = TIM_OCMode_PWM1;
	TIM_OCInitStruct.TIM_OCValue = 0;
	TIM_OCInitStruct.TIM_OCOutput = TIM_OCOutput_Enable;
	TIM_OCInitStruct.TIM_OCIdleState = TIM_OCIdleState_Low;
	TIM_OCInitStruct.TIM_OCNOutput = TIM_OCNOutput_Disable;
	TIM_OCInitStruct.TIM_OCNIdleState = TIM_OCNIdleState_Low;
	TIM_OCInit(TIM1,&TIM_OCInitStruct);
	TIM_Cmd(TIM1, ENABLE);																						 //TIM1
}

/**
* @brief TIM1
* @param 
* @retval 
*/
void TIM1_Driver(void)
{
	TIM1_PWM_GPIO_Config();
	TIM1_PWM_Mode_Config();
}

int main (void)
{
	u16 TIM_OC_Value = 0;
  TIM1_Driver();
  while(1)
	{
		TIM_OC_Value++;
		if(TIM_OC_Value > 1000)
		{
			TIM_OC_Value = 0;
		}
		TIM_SetOCxValue(TIM1,TIM_Channel_3,TIM_OC_Value);
		Software_Delay();
	}
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(u8* file, u32 line)
{
	/* User can add his own implementation to report the file name and line number,
	   ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
	printf("Wrong parameters value: file %s on line %d\r\n", file, line);
	/* Infinite loop */
	while (1)
	{
	}
}
#endif
