/******************************************************************************
  * @Example PT32x076_TIM
  * @author  ӦÿŶ
  * @version V1.0.0
  * @date    2023/7/15
  * @brief   ͨLPTIMȽֵжϣÿ0.5s˯еMCUͨڴӡϢ
  *          
  ******************************************************************************
  * @attention	Ϊ96001λֹͣλżУ
  *
	*			ʹø̣
	*							¼轫H3Power-Connectorġ3V3롰PER/3V3롰VDD1x2Pñժ
	*							H19Link-Connector2x8P3V3/GND/RXñVDD3V3۲
	*
	* ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣
  * ̼/ͻʹаıϢκ, * Pai-IC κֱӣ ӻ̷𺦸
  *
  * (C) Ȩ Pai-IC Microelectronics
  *
  *****************************************************************************/
	
#include "PT32x076.h"

/**
* @brief ʱ
* @param 
* @retval 
*/
void Software_Delay(void)
{
	u8 i, j,x;
	for(i=0; i<200; i++)
		for(j=0; j<200; j++)
			for(x=0; x<20; x++);
}

/**
* @brief UARTĸ
* @param 
* @retval 
*/
void UART_GPIO_Config(void)
{
	/* UARTܽŵĸù */
	GPIO_DigitalRemapConfig(AFIOA, GPIO_Pin_2, AFIO_AF_2, ENABLE);	//PA2 TX
	GPIO_DigitalRemapConfig(AFIOA, GPIO_Pin_3, AFIO_AF_2, ENABLE);	//PA3 RX
}

/**
* @brief UARTĹģʽ
* @param 
* @retval 
*/
void UART_Mode_Config(void)
{
	UART_InitTypeDef  UART_InitStruct;
	
	/*ʼUART0*/
	UART_InitStruct.UART_BaudRate = 9600;
	UART_InitStruct.UART_DataLength = UART_DataLength_8;
	UART_InitStruct.UART_StopBitLength = UART_StopBitLength_1;
	UART_InitStruct.UART_ParityMode = UART_Parity_None;
	UART_InitStruct.UART_Receiver = UART_Receiver_Enable;
	UART_Init(UART0, &UART_InitStruct);
	/*ʹUART0*/
	UART_Cmd(UART0, ENABLE);
}

/**
* @brief UART
* @param 
* @retval 
*/
void UART_Driver(void)
{
	UART_GPIO_Config();
	UART_Mode_Config();
}

/**
* @brief LPTIMʽ
* @param 
* @retval 
*/
void LPTIM_Mode_Config(void)
{
	TIM_TimeBaseInitTypeDef TimeBaseInitStruct;
	NVIC_InitTypeDef NVIC_InitStruct;

	/*ʹTIMER4NVIC*/
	NVIC_InitStruct.NVIC_IRQChannel = LPTIM_IRQn;
	NVIC_InitStruct.NVIC_IRQChannelCmd = ENABLE;
	NVIC_InitStruct.NVIC_IRQChannelPriority = 0x03;
	NVIC_Init(&NVIC_InitStruct);
	
	/* CNTʱ = 38.4khz/(psc+1)*/
	TimeBaseInitStruct.TIM_Prescaler = 38-1;
	TimeBaseInitStruct.TIM_Direction = TIM_Direction_Down;
	TimeBaseInitStruct.TIM_AutoReloadValue = 1000-1;
	TimeBaseInitStruct.TIM_InternalClockSource = LPTIM_InternalClockSource_LSI;
	
	/* ARRȽֵ */
	TIM_SetOCxValue(LPTIM,TIM_Channel_1,500);
	
	TIM_TimeBaseInit(LPTIM, &TimeBaseInitStruct);
	TIM_OCITConfig(LPTIM, TIM_OCIT_OC1I, ENABLE);
	TIM_Cmd(LPTIM, ENABLE);
}

/**
* @brief LPTIMʧܺ
* @param 
* @retval 
*/
void LPTIM_Disable(void)
{
	TIM_OCITConfig(LPTIM, TIM_OCIT_OC1I, DISABLE);
	NVIC_DisableIRQ(LPTIM_IRQn);
	UART_Driver();
	printf("wake up\r\n");
	TIM_Cmd(LPTIM, DISABLE);
}
/**
* @brief LPTIMѺ
* @param 
* @retval 
*/
void LPTIM_Wake_Sleep(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;

	GPIO_AnalogRemapConfig(AFIOA, GPIO_Pin_All, DISABLE);
	GPIO_AnalogRemapConfig(AFIOB, GPIO_Pin_All, DISABLE);
	GPIO_AnalogRemapConfig(AFIOC, GPIO_Pin_All, DISABLE);
	GPIO_AnalogRemapConfig(AFIOF, GPIO_Pin_All, DISABLE);
	
	GPIO_DigitalRemapConfig(AFIOA, GPIO_Pin_All&(~GPIO_Pin_13)&(~GPIO_Pin_14),AFIO_AF_None,DISABLE);	//SWDӿڲ
	GPIO_DigitalRemapConfig(AFIOB, GPIO_Pin_All,AFIO_AF_None,DISABLE);
	GPIO_DigitalRemapConfig(AFIOC, GPIO_Pin_All,AFIO_AF_None,DISABLE);	//LSE
	GPIO_DigitalRemapConfig(AFIOF, GPIO_Pin_All,AFIO_AF_None,DISABLE);

	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_All;			//ѡҪƵGPIO
	GPIO_InitStructure.GPIO_Pull = GPIO_Pull_Down;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_In;
	GPIO_Init(GPIOA, &GPIO_InitStructure);
	GPIO_Init(GPIOB, &GPIO_InitStructure);
	GPIO_Init(GPIOC, &GPIO_InitStructure);
	GPIO_Init(GPIOF, &GPIO_InitStructure);
	
	LPTIM_Mode_Config();	
	PWR_EnterDeepSleepMode(PWR_DeepSleepEntry_WFI);   //˯ߣжϻ

	LPTIM_Disable();
	Software_Delay();
}

int main (void)
{
	while(1)
	{
		LPTIM_Wake_Sleep();
	}
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(u8* file, u32 line)
{
	/* User can add his own implementation to report the file name and line number,
	   ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
	printf("Wrong parameters value: file %s on line %d\r\n", file, line);
	/* Infinite loop */
	while (1)
	{
	}
}
#endif
