/******************************************************************************
  * @Example PT32x076_IWDG
  * @author  ӦÿŶ
  * @version V1.0.0
  * @date    2023/7/15
  * @brief    ÿŹιͨӡ"ȴιȡιϢϵͳλظ"ιֻӡһ
  *          
  ******************************************************************************
  * @attention	Ϊ96001λֹͣλżУ
  *
	* ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣
  * ̼/ͻʹаıϢκ, * Pai-IC κֱӣ ӻ̷𺦸
  *
  * (C) Ȩ Pai-IC Microelectronics
  *
  *****************************************************************************/
	
#include "PT32x076.h"

/**
* @brief ʱ
* @param 
* @retval 
*/
void Software_Delay(void)
{
	u8 i, j,x;
	for(i=0; i<200; i++)
		for(j=0; j<200; j++)
			for(x=0; x<20; x++);
}

/**
* @brief UARTĸ
* @param 
* @retval 
*/
void UART_GPIO_Config(void)
{
	/* UARTܽŵĸù */
	GPIO_DigitalRemapConfig(AFIOA, GPIO_Pin_2, AFIO_AF_2, ENABLE);	//PA2 TX
	GPIO_DigitalRemapConfig(AFIOA, GPIO_Pin_3, AFIO_AF_2, ENABLE);	//PA3 RX
}

/**
* @brief UARTĹģʽ
* @param 
* @retval 
*/
void UART_Mode_Config(void)
{
	UART_InitTypeDef  UART_InitStruct;
	
	/*ʼUART0*/
	UART_InitStruct.UART_BaudRate = 9600;
	UART_InitStruct.UART_DataLength = UART_DataLength_8;
	UART_InitStruct.UART_StopBitLength = UART_StopBitLength_1;
	UART_InitStruct.UART_ParityMode = UART_Parity_None;
	UART_InitStruct.UART_Receiver = UART_Receiver_Enable;
	UART_Init(UART0, &UART_InitStruct);
	/*ʹUART0*/
	UART_Cmd(UART0, ENABLE);
}

/**
* @brief UART
* @param 
* @retval 
*/
void UART_Driver(void)
{
	UART_GPIO_Config();
	UART_Mode_Config();
}

/**
* @brief IWDG
* @param 
* @retval 
*/
void IWDG_Driver(u32 reloadvalue)
{	
	IWDG_LockCmd(IWDG,WDG_LockKey_Unlock);//IWDGĴ
	IWDG_ClockSourceConfig(IWDG,WDG_ClockSource_LSI);//ʱԴ
	IWDG_SetReload(IWDG, reloadvalue);//װؼĴֵ
	IWDG_ReloadCounter(IWDG);//ι(ؼ)
  IWDG_ResetCmd(IWDG, ENABLE);//Źλʹ
	IWDG_Cmd(IWDG, ENABLE);//ʹIWDG
	IWDG_LockCmd(IWDG, WDG_LockKey_Lock);	//סIWDGĴ
}

/**
* @brief IWDGι
* @param 
* @retval 
*/
void IWDG_Feed(void)
{
	IWDG_LockCmd(IWDG, WDG_LockKey_Unlock);//IWDGĴ
	IWDG_ReloadCounter(IWDG);//ι(ؼ)
	IWDG_LockCmd(IWDG, WDG_LockKey_Lock);//סIWDGĴ	
}

int main (void)
{
	UART_Driver();
	IWDG_Driver(32678);	//timeout=1s	
	printf("ȴιȡιϢϵͳλظ\r\n");
	while(1)
	{
		IWDG_Feed();//ι
	}
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(u8* file, u32 line)
{
	/* User can add his own implementation to report the file name and line number,
	   ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
	printf("Wrong parameters value: file %s on line %d\r\n", file, line);
	/* Infinite loop */
	while (1)
	{
	}
}
#endif
