/******************************************************************************
  * @Example PT32x076_UART
  * @author  ӦÿŶ
  * @version V1.0.0
  * @date    2023/7/15
  * @brief   ͨLPUARTջ˯µMCUûͨλݻMCU
  *          
  ******************************************************************************
  * @attention	Ϊ96001λֹͣλżУ
  *
	*			ʹø̣
	*							¼轫H3Power-Connectorġ3V3롰PER/3V3롰VDD1x2Pñժ
	*							H19Link-Connector2x8P3V3/GND/TXñҶ̽PA3PC11ţVDD3V3۲
	*
	* ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣
  * ̼/ͻʹаıϢκ, * Pai-IC κֱӣ ӻ̷𺦸
  *
  * (C) Ȩ Pai-IC Microelectronics
  *
  *****************************************************************************/
	
#include "PT32x076.h"

/**
* @brief ʱ
* @param 
* @retval 
*/
void Software_Delay(void)
{
	u8 i, j,x;
	for(i=0; i<200; i++)
		for(j=0; j<200; j++)
			for(x=0; x<50; x++);
}

/**
* @brief LPUARTĸ
* @param 
* @retval 
*/
void LPUART_GPIO_Config(void)
{
	/* UARTܽŵĸù */
	GPIO_DigitalRemapConfig(AFIOC, GPIO_Pin_10, AFIO_AF_2, ENABLE);	//PC10 TX
	GPIO_DigitalRemapConfig(AFIOC, GPIO_Pin_11, AFIO_AF_2, ENABLE);	//PC11 RX
}

/**
* @brief LPUARTĹģʽ
* @param 
* @retval 
*/
void LPUART_Mode_Config(void)
{
	UART_InitTypeDef  UART_InitStruct;
	NVIC_InitTypeDef  NVIC_InitStruct;
	/*ʼUART0*/
	UART_InitStruct.UART_BaudRate = 9600;
	UART_InitStruct.UART_DataLength = UART_DataLength_8;
	UART_InitStruct.UART_StopBitLength = UART_StopBitLength_1;
	UART_InitStruct.UART_ParityMode = UART_Parity_None;
	UART_InitStruct.UART_Receiver = UART_Receiver_Enable;
	UART_Init(LPUART0, &UART_InitStruct);
	
	LPUART_ClockSel(LPUART0,LPUART_Clocksource_LSI);
	UART_LowPowerConfig(LPUART0,UART_WakeupMethod_RXNE);//õ͹Ļģʽ
	UART_ITConfig(LPUART0,UART_IT_LPWUI,ENABLE);
	
	NVIC_InitStruct.NVIC_IRQChannel = LPUART0_IRQn;
	NVIC_InitStruct.NVIC_IRQChannelPriority = 0x03;
	NVIC_InitStruct.NVIC_IRQChannelCmd = ENABLE;
	NVIC_Init(&NVIC_InitStruct);

	/*ʹUART0*/
	UART_Cmd(LPUART0, ENABLE);
}

/**
* @brief LPUART
* @param 
* @retval 
*/
void LPUART_Driver(void)
{
	LPUART_GPIO_Config();
	LPUART_Mode_Config();
}

/**
* @brief LPUARTʧܺ
* @param 
* @retval 
*/
void LPUART_Disable(void)
{
	UART_ITConfig(LPUART0,UART_IT_LPWUI,DISABLE);
	NVIC_DisableIRQ(LPUART0_IRQn);
	UART_Cmd(LPUART0, DISABLE);
}

/**
* @brief 
* @param 
* @retval 
*/
void LPUART_Wake_Sleep(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;
	
	GPIO_AnalogRemapConfig(AFIOA, GPIO_Pin_All, DISABLE);
	GPIO_AnalogRemapConfig(AFIOB, GPIO_Pin_All, DISABLE);
	GPIO_AnalogRemapConfig(AFIOC, GPIO_Pin_All, DISABLE);
	GPIO_AnalogRemapConfig(AFIOF, GPIO_Pin_All, DISABLE);
	
	GPIO_DigitalRemapConfig(AFIOA, (GPIO_Pin_All&(~GPIO_Pin_13)&(~GPIO_Pin_14)),AFIO_AF_None,DISABLE);	//SWDӿڲ
	GPIO_DigitalRemapConfig(AFIOB, GPIO_Pin_All,AFIO_AF_None,DISABLE);
	GPIO_DigitalRemapConfig(AFIOC, (GPIO_Pin_All&(~GPIO_Pin_10)&(~GPIO_Pin_11)),AFIO_AF_None,DISABLE);	//LPUART0ӿڱָ
	GPIO_DigitalRemapConfig(AFIOF, GPIO_Pin_All,AFIO_AF_None,DISABLE);

	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_All;			//ѡҪƵGPIO
	GPIO_InitStructure.GPIO_Pull = GPIO_Pull_Down;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_In;
	GPIO_Init(GPIOB, &GPIO_InitStructure);
	GPIO_Init(GPIOC, &GPIO_InitStructure);
	GPIO_Init(GPIOF, &GPIO_InitStructure);
	GPIO_Init(GPIOA, &GPIO_InitStructure);
	
	LPUART_Driver();
	PWR_EnterDeepSleepMode(PWR_DeepSleepEntry_WFI);	//˯ߣжϻ
	
	LPUART_Disable();
	Software_Delay();	
}

int main (void)
{
	while(1)
	{
		LPUART_Wake_Sleep();
	}
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(u8* file, u32 line)
{
	/* User can add his own implementation to report the file name and line number,
	   ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
	printf("Wrong parameters value: file %s on line %d\r\n", file, line);
	/* Infinite loop */
	while (1)
	{
	}
}
#endif
