/******************************************************************************
  * @Example PT32x076_UART
  * @author  ӦÿŶ
  * @version V1.0.0
  * @date    2023/7/15
  * @brief   ͨLPUARTʵ־Ĭػܣַͨƥʵֽ/˳ĬģʽͨڴӡϢ
  *          
  ******************************************************************************
  * @attention	Ϊ96001λֹͣλżУ
  *
	* ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣
  * ̼/ͻʹаıϢκ, * Pai-IC κֱӣ ӻ̷𺦸
  *
  * (C) Ȩ Pai-IC Microelectronics
  *
  *****************************************************************************/
	
#include "PT32x076.h"

/**
* @brief ʱ
* @param 
* @retval 
*/
void Software_Delay(void)
{
	u8 i, j,x;
	for(i=0; i<200; i++)
		for(j=0; j<200; j++)
			for(x=0; x<100; x++);
}

/**
* @brief LPUARTĸ
* @param 
* @retval 
*/
void LPUART_GPIO_Config(void)
{
	/* UARTܽŵĸù */
	GPIO_DigitalRemapConfig(AFIOC, GPIO_Pin_10, AFIO_AF_2, ENABLE);	//PC10 TX
	GPIO_DigitalRemapConfig(AFIOC, GPIO_Pin_11, AFIO_AF_2, ENABLE);	//PC11 RX
}

/**
* @brief LPUARTĹģʽ
* @param 
* @retval 
*/
void LPUART_Mode_Config(void)
{
	UART_InitTypeDef  UART_InitStruct;
	/*ʼUART0*/
	UART_InitStruct.UART_BaudRate = 9600;
	UART_InitStruct.UART_DataLength = UART_DataLength_8;
	UART_InitStruct.UART_StopBitLength = UART_StopBitLength_1;
	UART_InitStruct.UART_ParityMode = UART_Parity_None;
	UART_InitStruct.UART_Receiver = UART_Receiver_Enable;
	UART_Init(LPUART0, &UART_InitStruct);
	
	UART_LoopBackModeCmd(LPUART0,ENABLE);//ػģʽ
	UART_MuteModeWakeupConfig(LPUART0,UART_MuteModeWakeup_AddressMatch);//þĬģʽ
	UART_MuteModeEnable(LPUART0);//Ĭģʽ
	UART_SetAddress(LPUART0,0x7F);//ƥַ
	/*ʹUART0*/
	UART_Cmd(LPUART0, ENABLE);
}

/**
* @brief LPUART
* @param 
* @retval 
*/
void LPUART_Driver(void)
{
	LPUART_GPIO_Config();
	LPUART_Mode_Config();
}

/**
* @brief UARTĸ
* @param 
* @retval 
*/
void UART_GPIO_Config(void)
{
	/* UARTܽŵĸù */
	GPIO_DigitalRemapConfig(AFIOA, GPIO_Pin_2, AFIO_AF_2, ENABLE);	//PA2 TX
	GPIO_DigitalRemapConfig(AFIOA, GPIO_Pin_3, AFIO_AF_2, ENABLE);	//PA3 RX
}

/**
* @brief UARTĹģʽ
* @param 
* @retval 
*/
void UART_Mode_Config(void)
{
	UART_InitTypeDef  UART_InitStruct;
	
	/*ʼUART0*/
	UART_InitStruct.UART_BaudRate = 9600;
	UART_InitStruct.UART_DataLength = UART_DataLength_8;
	UART_InitStruct.UART_StopBitLength = UART_StopBitLength_1;
	UART_InitStruct.UART_ParityMode = UART_Parity_None;
	UART_InitStruct.UART_Receiver = UART_Receiver_Enable;
	UART_Init(UART0, &UART_InitStruct);

	/*ʹUART0*/
	UART_Cmd(UART0, ENABLE);
}

/**
* @brief UART
* @param 
* @retval 
*/
void UART_Driver(void)
{
	UART_GPIO_Config();
	UART_Mode_Config();
}

int main (void)
{
	u16 Res = 0;
	u8 counter = 0;
 	LPUART_Driver();
	UART_Driver();
	while(1)
	{
		if(counter == 0)
		{
			UART_SendData(LPUART0,0x166);
			UART_SendData(LPUART0,0x5A);
		}
		else if(counter == 1)
		{
			UART_SendData(LPUART0,0x188);
			UART_SendData(LPUART0,0xA5);
		}
		else	
		{
			UART_SendData(LPUART0,0x17F);
			UART_SendData(LPUART0,0xFF);
		}
		
		if(UART_GetFlagStatus(LPUART0,UART_FLAG_RXNE)!=RESET)
		{
			Res = UART_ReceiveData(LPUART0);
			if(Res == 0x17F)
			{
				printf("ַƥ䣬˳Ĭģʽ\r\n");
				Res = UART_ReceiveData(LPUART0);
				if(Res == 0xFF)
				{
				printf("յΪ0x%2x\r\n",Res);
				}
			}
		}
		else
		{
			printf("ַƥ䣬־Ĭģʽ\r\n");
		}
		counter++;
		if(counter > 2)counter = 0;
		Software_Delay();
	}
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(u8* file, u32 line)
{
	/* User can add his own implementation to report the file name and line number,
	   ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
	printf("Wrong parameters value: file %s on line %d\r\n", file, line);
	/* Infinite loop */
	while (1)
	{
	}
}
#endif
