/******************************************************************************
  * @Example PT32x076_IFMC
  * @author  ӦÿŶ
  * @version V1.0.0
  * @date    2023/7/15
  * @brief   
  *          
  ******************************************************************************
  * @attention	Ϊ96001λֹͣλżУ
  *
	* ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣
  * ̼/ͻʹаıϢκ, * Pai-IC κֱӣ ӻ̷𺦸
  *
  * (C) Ȩ Pai-IC Microelectronics
  *
  *****************************************************************************/
	
#include "PT32x076.h"

/**
* @brief UARTĸ
* @param 
* @retval 
*/
void UART_GPIO_Config(void)
{
	/* UARTܽŵĸù */
	GPIO_DigitalRemapConfig(AFIOA, GPIO_Pin_2, AFIO_AF_2, ENABLE);	//PA2 TX
	GPIO_DigitalRemapConfig(AFIOA, GPIO_Pin_3, AFIO_AF_2, ENABLE);	//PA3 RX
}

/**
* @brief UARTĹģʽ
* @param 
* @retval 
*/
void UART_Mode_Config(void)
{
	UART_InitTypeDef  UART_InitStruct;
	
	/*ʼUART0*/
	UART_InitStruct.UART_BaudRate = 9600;
	UART_InitStruct.UART_DataLength = UART_DataLength_8;
	UART_InitStruct.UART_StopBitLength = UART_StopBitLength_1;
	UART_InitStruct.UART_ParityMode = UART_Parity_None;
	UART_InitStruct.UART_Receiver = UART_Receiver_Enable;
	UART_Init(UART0, &UART_InitStruct);

	/*ʹUART0*/
	UART_Cmd(UART0, ENABLE);
}

/**
* @brief UART
* @param 
* @retval 
*/
void UART_Driver(void)
{
	UART_GPIO_Config();
	UART_Mode_Config();
}

int main (void)
{
	UART_Driver();
	IFMC_SetPrescaler(32);//ǰHCLK=32MhzƵΪ1MhzṩIFMCΪʱ
	IFMC_ErasePage(0xF000);
	IFMC_ProgramWord(0x0000F000,123);
	IFMC_ProgramWord(0x0000F004,456);
	IFMC_ProgramWord(0x0000F008,0xCC);
	IFMC_ProgramWord(0x0000F00C,0xDD);

	printf("0x0000F000: %ld\r\n",IFMC_ReadWord(0x0000F000));
	printf("0x0000F004: %ld\r\n",IFMC_ReadWord(0x0000F004));
	printf("0x0000F008: %X\r\n",IFMC_ReadByte(0x0000F008));
	printf("0x0000F00C: %X\r\n",IFMC_ReadByte(0x0000F00C));
  while(1)
	{
		
	}
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(u8* file, u32 line)
{
	/* User can add his own implementation to report the file name and line number,
	   ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
	printf("Wrong parameters value: file %s on line %d\r\n", file, line);
	/* Infinite loop */
	while (1)
	{
	}
}
#endif
