/******************************************************************************
  * @Example PT32x076_IFMC
  * @author  ӦÿŶ
  * @version V1.0.0
  * @date    2023/7/15
  * @brief   ͨIAPAPPϸɲοĿ¼¡ToolļеġPT32x076x IAP_Bootloaderʹ˵
  *          
  ******************************************************************************
  * @attention	Ϊ192001λֹͣλżУ
  *
	* ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣
  * ̼/ͻʹаıϢκ, * Pai-IC κֱӣ ӻ̷𺦸
  *
  * (C) Ȩ Pai-IC Microelectronics
  *
  *****************************************************************************/
	
#include "PT32x076.h"
#include "string.h"

#define PACKET_SEQNO_INDEX      (1)
#define PACKET_SEQNO_COMP_INDEX (2)

#define PACKET_HEADER           (3)
#define PACKET_TRAILER          (2)
#define PACKET_OVERHEAD         (PACKET_HEADER + PACKET_TRAILER)
#define PACKET_SIZE             (128)
#define PACKET_1K_SIZE          (1024)

#define FILE_NAME_LENGTH        (256)
#define FILE_SIZE_LENGTH        (16)

#define SOH                     (0x01)  //128ֽݰʼ
#define STX                     (0x02)  //1024ֽڵݰʼ
#define EOT                     (0x04)  //
#define ACK                     (0x06)  //Ӧ
#define NAK                     (0x15)  //ûӦ
#define CA                      (0x18)  //ֹת
#define CRC16                   (0x43)  //'C' == 0x43, Ҫ 16-bit CRC 

#define ABORT1                  (0x41)  //'A' == 0x41, ûֹ 
#define ABORT2                  (0x61)  //'a' == 0x61, ûֹ

#define NAK_TIMEOUT             (0x40000)
#define MAX_ERRORS              (5)

#define CMD_STRING_SIZE       	128
#define BootAddress           	0x800
#define ApplicationAddress    	0x2000	//8kʼ
#define PAGE_SIZE             	0x200   //512 byte
#define FLASH_SIZE          	0x10000  	//64 KBytes

#define ww(addr, value)     (*((uint32_t volatile *) (addr)) = value)
#define rw(addr)            (*((uint32_t volatile *) (addr)))
u32 Detect_counter = 0;//Systick
uint8_t UART_Buffer[1024] = {0};

/**
* @brief û
* @param 
* @retval 
*/
void KEY_Driver(void)
{
	GPIO_InitTypeDef GPIO_InitStruct;
	GPIO_InitStruct.GPIO_Mode = GPIO_Mode_In;
	GPIO_InitStruct.GPIO_Pin = GPIO_Pin_1;
	GPIO_InitStruct.GPIO_Pull = GPIO_Pull_Up;
	GPIO_Init(GPIOA,&GPIO_InitStruct);
}

/**
* @brief UARTĸ
* @param 
* @retval 
*/
void UART_GPIO_Config(void)
{
	/* UARTܽŵĸù */
	GPIO_DigitalRemapConfig(AFIOA, GPIO_Pin_2, AFIO_AF_2, ENABLE);	//PA2 TX
	GPIO_DigitalRemapConfig(AFIOA, GPIO_Pin_3, AFIO_AF_2, ENABLE);	//PA3 RX
}

/**
* @brief UARTĹģʽ
* @param 
* @retval 
*/
void UART_Mode_Config(void)
{
	UART_InitTypeDef  UART_InitStruct;
	
	/*ʼUART0*/
	UART_InitStruct.UART_BaudRate = 19200;
	UART_InitStruct.UART_DataLength = UART_DataLength_8;
	UART_InitStruct.UART_StopBitLength = UART_StopBitLength_1;
	UART_InitStruct.UART_ParityMode = UART_Parity_None;
	UART_InitStruct.UART_Receiver = UART_Receiver_Enable;
	UART_Init(UART0, &UART_InitStruct);

	/*ʹUART0*/
	UART_Cmd(UART0, ENABLE);
}

/**
* @brief UART
* @param 
* @retval 
*/
void UART_Driver(void)
{
	UART_GPIO_Config();
	UART_Mode_Config();
}

/**
* @brief Systick
* @param 
* @retval 
*/
void Systick_Driver(void)
{
	uint32_t SYSCLK=0;
	SYSCLK = RCC_GetClockFreq(RCC_SYSCLK);//ϵͳʱ
	SysTick_Config(SYSCLK/200);//0.2msһ
}

/**
* @brief ַͺ
* @param data:ַ
* @retval 
*/
void UART_SendString(u8 *data)
{
	while (*data != '\0')//ֻҪַ'\0'ͼ
	{
		UART_SendData(UART0,*data);
		while(UART_GetFlagStatus(UART0,UART_FLAG_TXO)!=SET);
		data++;
	}
}

/**
* @brief ڵֽڷͺ
* @param data:ַ
* @retval 
*/
void UART_SendByte(u8 data)
{
	UART_SendData(UART0,data);
	while(UART_GetFlagStatus(UART0,UART_FLAG_TXO)!=SET);
}

/**
* @brief ȴ
* @param data:
* @retval ȴݽ
*/
u8 UART_WaitForData(u8 *data)
{
	if(UART_GetFlagStatus(UART0,UART_FLAG_RXNE)!=RESET)//ջзǿ
	{
		*data = UART_ReceiveData(UART0);//ݣ
		return 1;
	}
	else
	{
		return 0;
	}
}

/**
* @brief ȡPCλ
* @param 
* @retval ȡ
*/
u8 UART_GetPCData(void)
{
	u8 data = 0;
	while(Detect_counter<5000)
	{
		if(UART_WaitForData((u8*)&data))break;
	}
	return data;
}

/**
* @brief ܴڵֽں
* @param /ʱʱ
* @retval ʱ(0/-1)
*/
static  int32_t Receive_Byte (u8 *c,u32 timeout)
{
	while (timeout-- > 0)
	{
		if (UART_WaitForData(c) == 1)//һֽڡ
		{
				return 0;
		}
	}
	return -1;
}

/**
* @brief ܴڴ
* @param /ݳ/ʱʱ
* @retval Ƿɹ(0/-1)
*/
static int32_t Receive_Packet (u8 *data, s32 *length, u32 timeout)
{
    uint16_t i, packet_size;
    uint8_t c;
    *length = 0;
    if (Receive_Byte(&c, timeout) != 0)//һֽڣ==0ɹ
    {
        return -1;
    }
    switch (c)
    {
    case SOH:
        packet_size = PACKET_SIZE;//128
        break;
    case STX:
        packet_size = PACKET_1K_SIZE;//1024
        break;
    case EOT:				//
        return 0;
    case CA:				//ֹ
        if ((Receive_Byte(&c, timeout) == 0) && (c == CA))//CA.ʾֹ
        {
            *length = -1;
            return 0;
        }
        else
        {
            return -1;
        }
    case ABORT1:
    case ABORT2:
        return 1;		//ûֹ
    default:
        return -1;
    }
    *data = c;
    for (i = 1; i < (packet_size + PACKET_OVERHEAD); i ++)//ͷβȣ֡ĴСPACKET_OVERHEAD==5
    {
        if (Receive_Byte(data + i, timeout) != 0)	//ѶȡֽڴdataС
        {
            return -1;
        }
    }
    if (data[PACKET_SEQNO_INDEX] != ((data[PACKET_SEQNO_COMP_INDEX] ^ 0xff) & 0xff))//dara[1]data[2]Ϊ롣
    {
        return -1;
    }
    *length = packet_size;
    return 0;
}

u8 file_name[FILE_NAME_LENGTH];
//ûFlashƫ
u32 FlashDestination = ApplicationAddress;
u32 RamSource;

/**
* @brief YmodemЭ
* @param 
* @retval Ƿɹ(0/-1)
*/
int32_t UART_YmodemReceiveAndDownload(u8 *buf)
{
		u8 packet_data[PACKET_1K_SIZE + PACKET_OVERHEAD], file_size[FILE_SIZE_LENGTH], *file_ptr, *buf_ptr;
    s32 i, j, packet_length, session_done, file_done, packets_received, errors, session_begin, size = 0;
		u8 eot_count = 0;
    //ʼFlashַ
    FlashDestination = ApplicationAddress;	//ApplicationAddress==0X8000,BOOTLOADERflash
																						//̹bootloaderʱд0x8000 ~ 0xF5FFʵFlash0x0000~ 0x75FF
    for (session_done = 0, errors = 0, session_begin = 0; ;)
    {
        for (packets_received = 0, file_done = 0, buf_ptr = buf; ;)
        {
            switch (Receive_Packet(packet_data, &packet_length, NAK_TIMEOUT))//NAK_TIMEOUT==0x100000
            {	
						//0: ;  -1: ʱݰ
            case 0:		//																										
                errors = 0;
                switch (packet_length)
                {
                    //Ͷֹ
                case - 1:
                    UART_SendByte(ACK);
                    return 0;
                    //
                case 0://յEOTʱ䡣
                    UART_SendByte(ACK);
								if(eot_count==1)
										UART_SendByte(CRC16);
										eot_count++;
                    file_done = 1;
                    break;
                    //ݰݳȴġ
                default:
										if((packet_data[PACKET_SEQNO_INDEX] & 0xff) != (packets_received & 0xff))//packet_data[1]յ֡ԲϻᷢNAK
                    {
											if(packet_data[1]==0)
											{
											  UART_SendByte(ACK);
                        file_done = 1;
                        session_done = 1;
                        break;//˳switch (packet_length)ֱӵif(file_done!=0)
											}
                    }
                    else
                    {
                        if (packets_received == 0)//0֡ҪļݴС
                        {
                            //ļݰ
                            if (packet_data[PACKET_HEADER] != 0)//Ǵļ֡
                            {
                                //ļݰЧ
                                for (i = 0, file_ptr = packet_data + PACKET_HEADER; (*file_ptr != 0) && (i < FILE_NAME_LENGTH);)
                                {
                                    file_name[i++] = *file_ptr++;
                                }
                                file_name[i++] = '\0';
                                for (i = 0, file_ptr ++; (*file_ptr != ' ') && (i < FILE_SIZE_LENGTH);)
                                {
                                    file_size[i++] = *file_ptr++;
                                }
                                file_size[i++] = '\0';
																size=0;
																for(i=0;file_size[i] != '\0';i++)
																{
																	size*=10;
																	size+=file_size[i]-'0';	
																}
                                //ݰǷ
                                if (size > (FLASH_SIZE - 1))	//FLASH_SIZE=32K
                                {
                                    //
                                    UART_SendByte(CA);
                                    UART_SendByte(CA);
                                    return -1;
                                }
                                UART_SendByte(ACK);
                                UART_SendByte(CRC16);//ļʹС֡һackc
                            }
                            //ļݰգ
                            else
                            {
																//һ֡ݶġSOH 00 FF 0 0000......
                                UART_SendByte(ACK);
                                file_done = 1;
                                session_done = 1;
                                break;//˳switch (packet_length)ֱӵif(file_done!=0)䡣
                            }
                        }
                        //ݰ
                        else	//0֡⣬1,2,3ȵȡ
                        {
                            memcpy(buf_ptr, packet_data + PACKET_HEADER, packet_length);//packet_length=1281024crcд롣
                            RamSource = (uint32_t)buf;
                            for (j = 0; (j < packet_length) && (FlashDestination <  ApplicationAddress + size); j += 4)	//SIZEָļС
                            {
																	//ѽյݱдFlash
															    IFMC->AR  = FlashDestination;//Ҫдĵַ
		                              IFMC->DR  = *(uint32_t*)RamSource;//Ҫдݣ4ֽд
															    IFMC->CR = 0xADEB0121;//FLCMD,ӦMAIN CODEİȫΪ0xADEBдģʽһȴڣ	
																	FlashDestination += 4;
																	RamSource += 4;
                            }
                            UART_SendByte(ACK);//귢ACK.
                        }
                        packets_received ++;//	
                        session_begin = 1;
                    }
                }
                break;
            case 1:	//ûֹdefaultӦswitch (Receive_Packet(packet_data, &packet_length, NAK_TIMEOUT))
								UART_SendByte(CA);//CAʾֹ
                UART_SendByte(CA);
                return -3;
            default://ʱĻ
                if (session_begin > 0)
                {
                    errors ++;
                }
                if (errors > MAX_ERRORS)
                {
                    UART_SendByte(CA);
                    UART_SendByte(CA);
                    return 0;
                }
                UART_SendByte(CRC16);	//ַcʾݡ
                break;
            }
            if (file_done != 0)
            {
                break;
            }
        }
        if (session_done != 0)//ļΪգ
        {
            break;								
        }
    }
		UART_SendByte(8);
    return (int32_t)size;
}

/**
* @brief ڻȡAPP
* @param 
* @retval 
*/
void User_GetNewAPP(void)
{
	u8 PC_data = 0;
	static u8 WithPC_status = 0;
	while(Detect_counter<300)
	{
		switch(WithPC_status)
		{
			case 0:
				UART_SendString("5A5A5A6A\r\n");//λ
				WithPC_status = 1;//PC״̬־λ1
				break;
			case 1:
				PC_data = UART_GetPCData();//6ûյݽ
				if(PC_data == 0x31)//1ascii0X31
				{
					UART_SendByte(CRC16);//յ0x31ʱ򣬾ȷһCλȴ̫
					UART_YmodemReceiveAndDownload(&UART_Buffer[0]);//λļд
				}
				break;
		  default:
				break;
		}
	}
}

/**
* @brief ȡIAPʹ״̬
* @param 
* @retval 
*/
u32 IFMC_GetIAPStatus(void)
{
	return IFMC->BSR;
}

/**
* @brief IAPתַ
* @param 
* @retval 
*/
void IFMC_SetIAPAress(void)
{
	IFMC->IAPAR = 0x2000;//APPַ
}

int main (void)
{
	if(IFMC_GetReadProtectStatus() != SET)//δڶ״̬²Žв
	{
		if(IFMC_GetIAPStatus() != IFMC_BSR_IAPF)//жǷʹIAP
		{
			IFMC_SetPrescaler(32);	//HCLK=32MHz ƵΪ1MHzʱṩIFMCʱ 
			IFMC_IAPConfig(ENABLE);	//ʹIAP
			RCC_AdvancedSoftwareReset(RCC_AdvancedSoftwareReset_CWR);//ָλ
		}
	}
	KEY_Driver();//û
	UART_Driver();//UART0
	Systick_Driver();//ͨSystickⳬʱ
	User_GetNewAPP();//ͨڻȡûAPP
	while(1)
	{
		if(GPIO_ReadDataBit(GPIOA,GPIO_Pin_1)!=SET)//ûȡΪ͵ƽ
		{
			IFMC_SetIAPAress();//APPַ
			RCC_AdvancedSoftwareReset(RCC_AdvancedSoftwareReset_CPU);//CPUλ
		}
	}
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(u8* file, u32 line)
{
	/* User can add his own implementation to report the file name and line number,
	   ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
	printf("Wrong parameters value: file %s on line %d\r\n", file, line);
	/* Infinite loop */
	while (1)
	{
	}
}
#endif
