/******************************************************************************
  * @Example PT32x076_IFMC
  * @author  ӦÿŶ
  * @version V1.0.0
  * @date    2023/7/15
  * @brief   ͨIVTSܽжSRAMַУͨUSERѡǷסɿر
	*					 IVTSʱÿ1sLED̵˸ڴڴӡϢIVTSܣÿ1sLED˸ڴڴӡϢ
  *          
  ******************************************************************************
  * @attention	Ϊ96001λֹͣλżУ
  *
	* ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣
  * ̼/ͻʹаıϢκ, * Pai-IC κֱӣ ӻ̷𺦸
  *
  * (C) Ȩ Pai-IC Microelectronics
  *
  *****************************************************************************/
	
#include "PT32x076.h"
#include "string.h"
#include "PT32x076_it.h"

#define 	USER_KEY_PORT		GPIOA
#define 	USER_KEY_PIN		GPIO_Pin_1

#define		LED_PROT_RED		GPIOC
#define		LED_PIN_RED	    GPIO_Pin_12

#define		LED_PROT_GREEN	GPIOA
#define		LED_PIN_GREEN	  GPIO_Pin_11

#define		SYS_VECTOR_CNT  16
u32 MapToSramADDR[512/4] = {0};

/**
* @brief ʱ
* @param 
* @retval 
*/
void Software_Delay(void)
{
	u8 i, j,x;
	for(i=0; i<200; i++)
		for(j=0; j<200; j++)
			for(x=0; x<20; x++);
}

/**
* @brief û
* @param 
* @retval 
*/
void KEY_Driver(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;					//һGPIO_InitTypeDef͵Ľṹ
	/*ʼGPIO*/
	GPIO_InitStructure.GPIO_Pin = USER_KEY_PIN;			//ѡҪƵGPIO
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_In;	//ģʽΪ
	GPIO_InitStructure.GPIO_Pull = GPIO_Pull_Up;	//
	GPIO_Init(USER_KEY_PORT, &GPIO_InitStructure);				//ÿ⺯ʼGPIO
}

/**
* @brief LED
* @param 
* @retval 
*/
void LED_Driver(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;				//һGPIO_InitTypeDef͵Ľṹ
	GPIO_InitStructure.GPIO_Pin = LED_PIN_RED;			//ѡҪƵGPIO
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OutPP;		//ģʽΪͨ
	GPIO_InitStructure.GPIO_Pull = GPIO_Pull_Up;	//
	GPIO_Init(LED_PROT_RED, &GPIO_InitStructure);				//ÿ⺯ʼGPIO
		
	GPIO_InitStructure.GPIO_Pin = LED_PIN_GREEN;			//ѡҪƵGPIO
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OutPP;		//ģʽΪͨ
	GPIO_InitStructure.GPIO_Pull = GPIO_Pull_Up;	//
	GPIO_Init(LED_PROT_GREEN, &GPIO_InitStructure);				//ÿ⺯ʼGPIO
	
  GPIO_SetBits(LED_PROT_RED, LED_PIN_RED);					//GPIO״̬
	GPIO_SetBits(LED_PROT_GREEN, LED_PIN_GREEN);					//GPIO״̬
}

/**
* @brief UARTĸ
* @param 
* @retval 
*/
void UART_GPIO_Config(void)
{
	/* UARTܽŵĸù */
	GPIO_DigitalRemapConfig(AFIOA, GPIO_Pin_2, AFIO_AF_2, ENABLE);	//PA2 TX
	GPIO_DigitalRemapConfig(AFIOA, GPIO_Pin_3, AFIO_AF_2, ENABLE);	//PA3 RX
}

/**
* @brief UARTĹģʽ
* @param 
* @retval 
*/
void UART_Mode_Config(void)
{
	UART_InitTypeDef  UART_InitStruct;
	
	/*ʼUART0*/
	UART_InitStruct.UART_BaudRate = 9600;
	UART_InitStruct.UART_DataLength = UART_DataLength_8;
	UART_InitStruct.UART_StopBitLength = UART_StopBitLength_1;
	UART_InitStruct.UART_ParityMode = UART_Parity_None;
	UART_InitStruct.UART_Receiver = UART_Receiver_Enable;
	UART_Init(UART0, &UART_InitStruct);

	/*ʹUART0*/
	UART_Cmd(UART0, ENABLE);
}

/**
* @brief UART
* @param 
* @retval 
*/
void UART_Driver(void)
{
	UART_GPIO_Config();
	UART_Mode_Config();
}

/**
* @brief TIM2ʽ
* @param 
* @retval 
*/
void TIM2_Int_Diver(void)
{
	NVIC_InitTypeDef NVIC_InitStruct;								//һNVIC_InitTypeDef͵Ľṹ
	TIM_TimeBaseInitTypeDef  TIM_TimeBaseInitStruct;//һNVIC_InitTypeDef͵Ľṹ
	
	TIM_TimeBaseInitStruct.TIM_Prescaler = 3200-1;										 //32M/3200=0.01MHZ
	TIM_TimeBaseInitStruct.TIM_AutoReloadValue = 10000;								 //0.01MHZ*10000=1HZ
	TIM_TimeBaseInitStruct.TIM_Direction = TIM_Direction_Up;					 //ϼ
	TIM_TimeBaseInit(TIM2, &TIM_TimeBaseInitStruct);									 //ʼTIM2
	
	TIM_OCITConfig(TIM2,TIM_OCIT_ARI,ENABLE);									//ʱжϳʼ
	
	NVIC_InitStruct.NVIC_IRQChannel=TIM2_IRQn;								//ʱжԴ
	NVIC_InitStruct.NVIC_IRQChannelPriority=0x00;							//жȼ
	NVIC_InitStruct.NVIC_IRQChannelCmd=ENABLE;								//ʹNVIC
	NVIC_Init(&NVIC_InitStruct);															//ʼNVIC	
	
	TIM_Cmd(TIM2, ENABLE);																		//TIM2
}

/**
* @brief ʹIVTS/ԶжӳSRAM
* @param 
* @retval 
*/
void IFMC_IVTS_Enable(void)
{
	__disable_irq();
	IFMC_IVTSEnable((u32)MapToSramADDR);
	__enable_irq();
}

/**
* @brief ԶTIM2жϷ
* @param 
* @retval 
*/
void SRAM_TIM2_Handler(void)
{
	if(TIM_GetFlagStatus(TIM2,TIM_FLAG_ARF) != RESET)
	{
		TIM_ClearFlag(TIM2,TIM_FLAG_ARF);
		printf("IVTS,SRAMеTIM2жϣϢжϷӡ\r\n");
		GPIO_SetBits(LED_PROT_RED, LED_PIN_RED);
		GPIO_ReverseBits(LED_PROT_GREEN,LED_PIN_GREEN);
	}
}

/**
* @brief Զж
* @param 
* @retval 
*/
extern void Reset_Handler(void);
void IFMC_InterruptInSrramConfig(void)
{
	MapToSramADDR[1] = (u32)Reset_Handler;//Reset Handler
	MapToSramADDR[2] = (u32)NMI_Handler;//NMI Handler
	MapToSramADDR[3] = (u32)HardFault_Handler;//HardFault_Handler
	MapToSramADDR[SYS_VECTOR_CNT + TIM2_IRQn] = (u32)SRAM_TIM2_Handler;//ԭȴTIM2жϷַĴΪԶ
}

int main (void)
{
	KEY_Driver();
	UART_Driver();
	LED_Driver();
	printf("ûǷIVTS,ͨUSERѡ(ΪɿΪر) \r\n");
	TIM2_Int_Diver();
	IFMC_InterruptInSrramConfig();
  while(1)
	{
		if(GPIO_ReadDataBit(USER_KEY_PORT,USER_KEY_PIN) != SET)
		{
			IFMC_IVTS_Enable();
		}
		else
		{
			IFMC_IVTSDisable();
		}
	}
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(u8* file, u32 line)
{
	/* User can add his own implementation to report the file name and line number,
	   ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
	printf("Wrong parameters value: file %s on line %d\r\n", file, line);
	/* Infinite loop */
	while (1)
	{
	}
}
#endif
