/******************************************************************************
  * @file   PT32x076_conf.h
  * @author  ӦÿŶ
  * @version V1.0.0
  * @date    2020/10/19
  * @brief    
  *          
  ******************************************************************************
  * @attention
  *
  *
  *****************************************************************************/

  

/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef PT32x076_CONF_H
#define PT32x076_CONF_H


#define RETARGET_UART0      1
#define RETARGET_UART1      2
#define RETARGET_UART2      3
#define RETARGET_UART3      4

#define RETARGET_PORT        RETARGET_UART0

#if (RETARGET_PORT == RETARGET_UART0)
  #define RETARGET_UART_PORT       UART0
  #define RETARGET_COM_PORT        COM1
	#define RETARGET_UART_IRQn       UART0_IRQn
#elif (RETARGET_PORT == RETARGET_UART1)
  #define RETARGET_UART_PORT       UART1
  #define RETARGET_COM_PORT         COM2
	#define RETARGET_UART_IRQn       UART1_IRQn
#elif (RETARGET_PORT == RETARGET_UART2)
  #define RETARGET_UART_PORT       UART2
  #define RETARGET_COM_PORT         COM3
#elif (RETARGET_PORT == RETARGET_UART3)
  #define RETARGET_UART_PORT       UART3
  #define RETARGET_COM_PORT         COM4
#endif

/* Includes ------------------------------------------------------------------*/
/* Comment the line below to disable peripheral header file inclusion */
#include "PT32x076_adc.h"
#include "PT32x076_aes.h"
#include "PT32x076_beep.h"
#include "PT32x076_cmp.h"
#include "PT32x076_crc.h"
#include "PT32x076_dma.h"
#include "PT32x076_exti.h"
#include "PT32x076_gpio.h"
#include "PT32x076_i2c.h"
#include "PT32x076_id.h"
#include "PT32x076_ifmc.h"
#include "PT32x076_iwdg.h"
#include "PT32x076_ldac.h"
#include "PT32x076_nvic.h"
#include "PT32x076_opa.h"
#include "PT32x076_pwr.h"
#include "PT32x076_rcc.h"
#include "PT32x076_rtc.h"
#include "PT32x076_spi.h"
#include "PT32x076_tim.h"
#include "PT32x076_uart.h"
#include "PT32x076_wwdg.h"
/* Exported types ------------------------------------------------------------*/
/* Exported constants --------------------------------------------------------*/
/* Exported macro ------------------------------------------------------------*/


#ifdef  USE_FULL_ASSERT

/**
  * @brief  The assert_param macro is used for function's parameters check.
  * @param  expr: If expr is false, it calls assert_failed function which reports 
  *         the name of the source file and the source line number of the call 
  *         that failed. If expr is true, it returns no value.
  * @retval None
  */
  #define assert_param(expr) ((expr) ? (void)0 : assert_failed((uint8_t *)__FILE__, __LINE__))
/* Exported functions ------------------------------------------------------- */
  void assert_failed(uint8_t* file, u32 line);
#else
  #define assert_param(expr) ((void)0)
#endif /* USE_FULL_ASSERT */

#endif 


