/********************************************************************************
  * @file    PT32x076_system.c
  * @author  ӦÿŶ
  * @version V1.0.0
  * @date    2023/7/15
  * @brief   This file provides the clock configuration for MCU.
	*
  * @attention
  *
  * ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣
  * ̼/ͻʹаıϢκ, * Pai-IC κֱӣӻ̷𺦸
  *
  * (C) Ȩ Pai-IC Microelectronics
  *******************************************************************************/

/* Includes ------------------------------------------------------------------*/
#include "PT32x076.h"


/** @addtogroup PT32x03x_StdPeriph_Driver
  * @{
  */


/** @addtogroup CLK
  * @{
  */


/** @defgroup CLK_Private_Defines
  * @{
  */

/**
  * @}
  */
void Wait_ClockReady(void)
{
	u8 i, j;
	for(i = 0; i < 100; i++)
		for(j = 0; j < 48; j++);
}



//<<< Use Configuration Wizard in Context Menu >>>
/*--------------------- Clock Configuration ----------------------------------
//
//    <h> HSI(32M)
//      <q0>    ʹ
//                <i> Ĭ = ENABLE
//    </h>
//
//    <h> LSIʱ
//      <o1> LSIʱƵѡ
//                <0=> 38.4kHz 
//                <1=> 32kHz
//                <i> Ĭ = 38.4kHz
//    </h>
//
//    <h> HSE(4~25M)
//      <e2>    ʹ
//                <i> Ĭ = DISABLE
//        <o3>  ⲿʱԴ
//                <0=> ⲿپ 
//                <1=> ʱ
//      </e>
//    </h>
//    <h> ⲿʱ/(32.768KHz)
//      <e4>    ʹ
//                <i> Ĭ = DISABLE
//        <o5>  ⲿʱԴ
//                <0=> ʱ
//                <1=> ⲿ
//      </e>
//    </h>
//    <h> PLL
//      <i> PLL=clk*pllƵϵ/pllƵϵ
//      <e6>    PLLʹ
//                <i> Ĭ  = DISABLE
//        <o7>  PLLʱԴ
//                <0=> HSI
//                <1=> HSE
//                <i> ĬPLLʱԴ = HSI
//        <o8>  PLLƵϵ
//                <6=> 6
//                <7=> 7
//                <8=> 8
//                <9=> 9
//                <10=> 10
//                <11=> 11
//                <12=> 12
//                <13=> 13
//                <14=> 14
//                <15=> 15
//                <16=> 16
//                <17=> 17
//                <18=> 18
//                <19=> 19
//                <20=> 20
//                <21=> 21
//                <22=> 22
//                <23=> 23
//                <24=> 24
//                <25=> 25
//                <26=> 26
//                <27=> 27
//                <28=> 28
//                <29=> 29
//                <30=> 30
//				        <31=> 31
//				        <32=> 32
//                <i> Ĭ6Ƶ
//        <o9>  PLLƵϵ
//                <1=> 1
//                <2=> 2
//                <3=> 3
//                <4=> 4
//                <5=> 5
//                <6=> 6
//                <7=> 7
//                <8=> 8
//                <i> Ĭ1Ƶ
//      </e>
//    </h>
//
//    <h> ϵͳʱ(HS_CLK)
//      <o10>    ϵͳʱԴ
//                <0=> HSI
//                <1=> HSE
//                <2=> PLL
//                <i> ĬϵͳʱԴ = HSI
//      <o11>  HCLKƵ
//                <i> ĬֵΪ1(Ƶ = 1)
//                <i> дֵΧ1-32(ӦƵ1-32)
//      <o12>  PCLKƵ
//                <i> ĬֵΪ1(Ƶ = 1)
//                <i> дֵΧ1-32(ӦƵ1-32)
//    </h>
//
//    <h> IFMC 
//      <o13>   Flash ȴ
//                <0=> 0 WS
//                <1=> 1 WS
//                <2=> 2 WS
//                <3=> 3 WS
//                <4=> 4 WS
//                <5=> 5 WS
//                <6=> 6 WS
//                <7=> 7 WS
//                <i> 0 WS:  1 KHz <= HCLK <= 25 MHz
//                <i> 1 WS: 25 MHz <  HCLK <= 50 MHz
//                <i> 2 WS: 50 MHz <  HCLK <= 75 MHz
//                <i> 3 WS: 75 KHz <= HCLK <= 100 MHz
//                <i> 4 WS: 100 MHz <  HCLK <= 125 MHz
//                <i> 5 WS: 125 MHz <  HCLK <= 150 MHz
//                <i> 6 WS: 150 MHz <  HCLK <= 175 MHz
//                <i> 7 WS: 175 MHz <  HCLK <= 200 MHz
//    </h>
//
//    <h>  MCO
//      <e14>    MCOʹ
//                <i> Ĭ = DISABLE
//        <o15>    MCOʱԴ
//                <0=> HSI
//                <1=> HSE
//                <2=> PLL
//                <3=> LSI
//                <4=> SYS_CLK
//                <5=> LSE
//        <o16>    MCO
//                <0=> PA8
//                <1=> PA9
//                <2=> PB2
//        <o17>   MCOƵ
//                <0=> 1
//                <1=> 2
//                <2=> 4
//                <3=> 8
//                <4=> 16
//    </e>
//    </h>
//
//    <o18>ǰHSEƵ
//    <i>Default: 16000000 (Unit:Hz)
//    <0-100000000>
*/


/** @defgroup CLK_Private_Defines
  * @{
  */

#define HSI_ENABLE	(1)     /*!< 0: DISABLE,  1: ENABLE                                               */
#define LSI_CFS	(0)         /*!< 0: 38.4Khz,  1: 32Khz                                               */
#define HSE_ENABLE	(0)     /*!< 0: DISABLE,  1: ENABLE                                               */
#define HSE_SRC  (0)       /*!< 0: CRYSTAL,  1: EXCLK 																						*/
#define LSE_ENABLE	(0)     /*!< 0: DISABLE,  1: ENABLE                                               */
#define LSE_SRC	  (1)     /*!< 0: EXCLK,    1: CRYSTAL                                              */
#define PLL_CLK_ENABLE	(0)     /*!< 0: DISABLE,  1: ENABLE                                               */
#define PLL_CLK_SRC	(0)         /*!< 0: HSI,   1: HSE                                */
#define PLL_CLK_MUL (6)         /*!< 1: DIV1,     2: DIV2,   3: DIV3,   4: DIV4,   5: DIV5,  6: DIV6  ...  32: DIV32  */
#define PLL_CLK_DIV (3)      /*!< 1: PREDIV1,  2: PREDIV2,3: PREDIV3,4: PREDIV4,5: PREDIV5,        ...32: PREDIV32 */
#define HCLK_SRC	(0)     /*!< 0: HSI, 1: HSE    2:PLL     3:LSI          */
#define HCLK_DIV	(1)     /*!< 1-32: DIV1-32       */
#define PCLK_DIV	(1)     /*!< 1-32: DIV1-32       */
#define WAIT_STATE	(1)   /*!< 0: 0 WS,     1: 1 WS,   2: 2 WS,                                     */
#define MCO_ENABLE	(0)   /*!< 0: DISABLE,  1: ENABLE                                               */
#define MCO_SRC		(0)     /*!< 0: HSI, 1: HSE    2:PLL_CLK     3:LSI       4:SYS_CLK    5:LSE*/
#define MCO_PINSEL	(0)   /*!< 0: PA8,      1: PA9,    2: PB2                                            */
#define MCO_DIV		(0)     /*!< 0: DIV1,     1: DIV2,   2: DIV4,   3: DIV8,   4: DIV16							    */
#define MCU_SYSTICK_FREQUENCE (16000000)


#define  HSI_VALUE     32000000UL

/**
  * @}
  */

/** @defgroup CLK_Private_Functions
  * @{
  */

/**
* @brief ʱԴ
* @param HSI_ENABLE	ָ,ƬRC32Mʱʹܿ
* @param HSE_ENABLE	ָ,ⲿƵʱʹܿ
* @retval None
*/
void CLOCK_Cmd(void)
{
#if (HSE_ENABLE == 1)
	#if (HSE_SRC==0)
		GPIO_DigitalRemapConfig(AFIOF, GPIO_Pin_0, AFIO_AF_2, ENABLE);
		GPIO_DigitalRemapConfig(AFIOF, GPIO_Pin_1, AFIO_AF_2, ENABLE);
		RCC_ClockSourceConfig(RCC_ClockSource_HSE, ENABLE);
	#else
		RCC_ClockSourceConfig(RCC_ClockSource_HSEExternal, ENABLE);
	#endif
#else
	RCC_ClockSourceConfig(RCC_ClockSource_HSE, DISABLE);
#endif

#if (HSI_ENABLE == 1)
	RCC_ClockSourceConfig(RCC_ClockSource_HSI, ENABLE);	//ʹڲRC 32M
#else
//	RCC_ClockSourceConfig(RCC_ClockSource_HSI, DISABLE);	//رڲRC 32M
#endif

#if (LSE_ENABLE ==1)
	#if (LSE_SRC ==0)
	  RCC_ClockSourceConfig(RCC_ClockSource_LSEExternal, ENABLE);
	#else
		GPIO_DigitalRemapConfig(AFIOC, GPIO_Pin_14, AFIO_AF_2, ENABLE);
		GPIO_DigitalRemapConfig(AFIOC, GPIO_Pin_15, AFIO_AF_2, ENABLE);
		RCC_ClockSourceConfig(RCC_ClockSource_LSE, ENABLE);
	#endif
#else
    RCC_ClockSourceConfig(RCC_ClockSource_LSE, DISABLE);
#endif
u8 LSI_TRIM=0;

  LSI_TRIM=(*((u8 volatile *) (0x4001FF80)));
	if(LSI_CFS==1)
	{
	  RCC->LSICR=((LSI_TRIM<<16)|0xBF83);
	}
	else
	{
	  RCC->LSICR=((LSI_TRIM<<16)|0xBF81);			
	}


}

/**
* @brief ʱԴ໷
* @param PLL_CLK_ENABLE		ָ,໷ʹ
* @param PLL_CLK_SRC			ָ,
*     @arg 0: ƵʱԴѡڲRC 32M
*     @arg 1: ƵʱԴѡⲿʱ
*     @arg 2: ƵʱԴѡڲRC 32K
* @retval None
*/
void CLOCK_PLLConfig(void)
{
#if (PLL_CLK_ENABLE == 1)
	RCC_ClockSourceConfig(RCC_ClockSource_PLL, DISABLE);
	RCC->PLLCFGR1 &= ~RCC_PLLCFGR1_MUL;
	RCC->PLLCFGR1 |= ((PLL_CLK_MUL-1)<<4);
	RCC->PLLCFGR1 &= ~RCC_PLLCFGR1_DIV;
	RCC->PLLCFGR1 |= ((PLL_CLK_DIV-1)<<12);
	#if (PLL_CLK_SRC == 0 )
		#if (HSI_ENABLE == 0)
			#error "PLL_CLK ʱԴHSI δʹ "
		#else
			RCC_PLLClockSourceConfig(RCC_PLLClockSource_HSI);
		#endif
	#endif
	
	#if (PLL_CLK_SRC == 1 )
		#if (HSE_ENABLE == 0)
			#error "PLL_CLK ʱԴHSE δʹ"
		#else
			RCC_PLLClockSourceConfig(RCC_PLLClockSource_HSE);
		#endif
	#endif
	
	RCC_ClockSourceConfig(RCC_ClockSource_PLL, ENABLE);
#else
	RCC_ClockSourceConfig(RCC_ClockSource_PLL, DISABLE);
#endif
}

/**
* @brief IFMCȡָ
* @param None
* @retval None
*/
void IFMC_Config(void)
{
	uint32_t tmpdiv=0; 
	float tmprem=0;
	IFMC_SetLatency(WAIT_STATE);
	tmpdiv = ((RCC_GetClockFreq(RCC_HCLK)/(HCLK_DIV+1))/1000000);
	tmprem = ((RCC_GetClockFreq(RCC_HCLK)/(HCLK_DIV+1))%1000000);
	if(tmprem!=0)
	{
	  IFMC_SetPrescaler(tmpdiv+1);
	}
	else
	{
	  IFMC_SetPrescaler(tmpdiv);
	}

}

/**
* @brief ϵͳʱ
* @param HCLK_SRC		ָ,
*     @arg 0: ʱԴѡڲRC32M
*     @arg 1: ʱԴѡⲿʱ
*     @arg 2: ʱԴѡڲPLLƵʱ
* @param HCLK_DIV		ָ,HCLKķƵϵ
* @param PCLK_DIV		ָ,PCLKķƵϵ
* @retval None
*/
void CLOCK_SystemClockConfig(void)
{
	IFMC_SetLatency(7);
	#if (HCLK_SRC == 0 )
		#if (HSI_ENABLE == 0)
			#error "ϵͳʱԴHSI δʹ"
		#else
			RCC_SetSystemClock(RCC_SystemClock_HSI);
		#endif
	#endif
	
	#if (HCLK_SRC == 1 )
		#if (HSE_ENABLE == 0)
			#error "ϵͳʱԴHSE δʹ"
		#else
			Wait_ClockReady();
			RCC_SetSystemClock(RCC_SystemClock_HSE);
			//ʱӰȫƴ
			if (HSI_ENABLE == 0)	RCC_ClockSourceConfig(RCC_ClockSource_HSI, DISABLE);	//رڲRC 32M
		#endif
	#endif
	
	#if (HCLK_SRC == 2 )
		#if (PLL_CLK_ENABLE == 0)
			#error "ϵͳʱԴPLL_CLK δʹ"
		#else
			RCC_SetSystemClock(RCC_SystemClock_PLL);
			Wait_ClockReady();
			//ʱӰȫƴ
			if(HSI_ENABLE == 0) 
				RCC_ClockSourceConfig(RCC_ClockSource_HSI, DISABLE);	//رڲRC 32M
		#endif
	#endif
	
	RCC_HCLKSetPrescaler(HCLK_DIV-1);	//HCLKƵѡ
	RCC_PCLKSetPrescaler(PCLK_DIV-1);	//PCLKƵѡ
	if((RCC_GetSystemClockSelection()) != HCLK_SRC)	//ϵͳʱѡ
	{
		while(1);
	}
	RCC_SetSystemClockAfterWakeUp(RCC_SystemClockAfterWakeUp_PreviousClock);
}

/**
* @brief ϵͳʱ
* @param MCO_ENABLE	ָ,ϵͳʱʹ
* @param MCO_PINSEL		ָ,
*     @arg 0: ϵͳʱPA8
*     @arg 1: ϵͳʱPD1
* @param MCO_DIV		ϵͳʱķƵ
* @retval None
*/
void CLOCK_MCOConfig(void)
{
	#if (MCO_ENABLE == 1)
		#if (MCO_SRC == 0 )
			#if (HSI_ENABLE == 0)
				#error "ϵͳʱԴHSI δʹ"
			#else
				RCC_SetMCOSource(RCC_ClockOutput_HSI);
			#endif
		#endif
		
		#if (MCO_SRC == 1 )
			#if (HSE_ENABLE == 0)
				#error "ϵͳʱԴHSE δʹ"
			#else
				RCC_SetMCOSource(RCC_ClockOutput_HSE);
			#endif
		#endif
		
		#if (MCO_SRC == 2 )
			#if (PLL_CLK_ENABLE == 0)
				#error "ϵͳʱԴPLL_CLK δʹ"
			#else
				RCC_SetMCOSource(RCC_ClockOutput_PLL);
			#endif
		#endif
		
		#if (MCO_SRC == 3 )
			RCC_ClockSourceConfig(RCC_ClockSource_LSI, ENABLE);	//ڲƵʱʹ
			RCC_SetMCOSource(RCC_ClockOutput_LSI);
		#endif
		
		#if (MCO_SRC == 4 )
			RCC_SetMCOSource(RCC_ClockOutput_SYSCLK);
		#endif
		#if (MCO_SRC == 5 )		
			RCC_SetMCOSource(RCC_ClockOutput_LSE);
		#endif		
		#if (MCO_PINSEL == 0)
			GPIO_DigitalRemapConfig(AFIOA, GPIO_Pin_8, AFIO_AF_0, ENABLE);
		#endif
		
		#if (MCO_PINSEL == 1)
			GPIO_DigitalRemapConfig(AFIOA, GPIO_Pin_9, AFIO_AF_0, ENABLE);
		#endif
		
		#if (MCO_PINSEL == 2)
			GPIO_DigitalRemapConfig(AFIOB, GPIO_Pin_2, AFIO_AF_0, ENABLE);
		#endif
		
		RCC_MCOSetPrescaler(MCO_DIV);
	#endif
}

/**
* @brief ȡϵͳʱ
* @param None
* @retval None
*/
u32 clk_get_sysclk(void)
{
	u32 SystemCoreClock;
	u32 SSRC=(RCC->CFGR&RCC_CFGR_SCW);
	u32 PSRC=((RCC->PLLCFGR1&RCC_PLLCFGR1_SRC)>>1);
	u32 PMUL=((RCC->PLLCFGR1&RCC_PLLCFGR1_MUL)>>4);
	u32 PDIV=((RCC->PLLCFGR1&RCC_PLLCFGR1_DIV)>>12);
	switch(SSRC)
	{
		case 0:
			SystemCoreClock = HSI_VALUE;
			break;
		case 1:
			SystemCoreClock = MCU_SYSTICK_FREQUENCE;
			break;
		case 2:
			if(PSRC == 0)
			{
				SystemCoreClock = ((HSI_VALUE*(PMUL+1)/(PDIV+1)));
			}
			else if(PSRC == 1)
			{
				SystemCoreClock = ((MCU_SYSTICK_FREQUENCE*(PMUL+1)/(PDIV+1)));
			}
			break;
		
		default:
			break;
	}
	return SystemCoreClock;
}

/**
* @brief ϵͳʱӳʼ
* @param None
* @retval None
*/
void SystemInit (void)
{
	/* ʱʹ */
	CLOCK_Cmd();
	/* Ƶʱ */
	CLOCK_PLLConfig();
	/* ϵͳʱѡ */
	CLOCK_SystemClockConfig();
	/* Flash ȴ */
	IFMC_Config();
	/* ϵͳʱ */
	CLOCK_MCOConfig();
}

//<<< end of configuration section >>>

/**
  * @}
  */


/**
  * @}
  */


/**
  * @}
  */


/******************* (C) Ȩ Pai-IC Microelectronics *****END OF FILE****/

