/******************************************************************************
  * @Example PT32x076_DMA
  * @author  ӦÿŶ
  * @version V1.0.0
  * @date    2023/7/15
  * @brief   ͨSPIԷմDMA䣬ͨڴӡû轫SPI_MISOSPI_MOSI̽PA6PA7ʵֻػշ
  *          
  ******************************************************************************
  * @attention	Ϊ96001λֹͣλżУ
  *
	* ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣
  * ̼/ͻʹаıϢκ, * Pai-IC κֱӣ ӻ̷𺦸
  *
  * (C) Ȩ Pai-IC Microelectronics
  *
  *****************************************************************************/
	
#include "PT32x076.h"

u16 SPI0_VAL[10] = {0};
u16 SPI0_TX_Buf[10] = {0,1,2,3,4,5,6,7,8,9};

/**
* @brief ʱ
* @param 
* @retval 
*/
void Software_Delay(void)
{
	u8 i, j;
	for(i=0; i<200; i++)
		for(j=0; j<200; j++);
}

/**
* @brief UARTĸ
* @param 
* @retval 
*/
void UART_GPIO_Config(void)
{
	/* UARTܽŵĸù */
	GPIO_DigitalRemapConfig(AFIOA, GPIO_Pin_2, AFIO_AF_2, ENABLE);	//PA2 TX
	GPIO_DigitalRemapConfig(AFIOA, GPIO_Pin_3, AFIO_AF_2, ENABLE);	//PA3 RX
}

/**
* @brief UARTĹģʽ
* @param 
* @retval 
*/
void UART_Mode_Config(void)
{
	UART_InitTypeDef  UART_InitStruct;
	
	/*ʼUART0*/
	UART_InitStruct.UART_BaudRate = 9600;
	UART_InitStruct.UART_DataLength = UART_DataLength_8;
	UART_InitStruct.UART_StopBitLength = UART_StopBitLength_1;
	UART_InitStruct.UART_ParityMode = UART_Parity_None;
	UART_InitStruct.UART_Receiver = UART_Receiver_Enable;
	UART_Init(UART0, &UART_InitStruct);

	/*ʹUART0*/
	UART_Cmd(UART0, ENABLE);
}

/**
* @brief UART
* @param 
* @retval 
*/
void UART_Driver(void)
{
	UART_GPIO_Config();
	UART_Mode_Config();
}

/**
* @brief DMAģʽ
* @param 
* @retval 
*/
void DMA_Mode_Config(void)
{
	DMA_InitTypeDef DMA_InitStruct;
	DMA_StructInit(&DMA_InitStruct);
	
	DMA_InitStruct.DMA_SourceBaseAddress = (u32)&SPI0->DR;//Դַ
	DMA_InitStruct.DMA_DestinationBaseAddress = (u32)&SPI0_VAL;//Ŀĵַ
	DMA_InitStruct.DMA_NumberOfData = 10;//Ҫݵ
	DMA_InitStruct.DMA_SourceDataSize = DMA_SourceDataSize_Half;//ԴDMAĴݿ
	DMA_InitStruct.DMA_DestinationDataSize = DMA_DestinationDataSize_Half;//DMAĿĵصĴݿ
	DMA_InitStruct.DMA_SourceAddressIncrement = DMA_SourceAddressIncrement_Disable;//DMAԴַʹ
	DMA_InitStruct.DMA_DestinationAddressIncrement = DMA_DestinationAddressIncrement_Enable;//DMAĿĵַ
	DMA_InitStruct.DMA_Direction = DMA_Direction_PeripheralToMemory;//䷽
	DMA_InitStruct.DMA_CircularMode = DMA_CircularMode_Disable;//ѭģʽ
	DMA_InitStruct.DMA_Burst = DMA_Burst_1Unit;
	
	DMA_PeripheralConfig(DMA,DMA_CHNUM_0,DMA_ChannelPERIPH_SPI0TX);//DMAͨ0SPI0_RX
	DMA_Init(DMA_Channel0,&DMA_InitStruct);//ʼDMA
	DMA_Cmd(DMA_Channel0,ENABLE);//ʹ
}

/**
* @brief SPIĸ
* @param 
* @retval 
*/
void SPI_GPIO_Config(void)
{
	GPIO_DigitalRemapConfig(AFIOA, GPIO_Pin_4, AFIO_AF_1, ENABLE);	//SPI_CSֹܸ
	GPIO_DigitalRemapConfig(AFIOA, GPIO_Pin_5, AFIO_AF_1, ENABLE);	//SPI_SCKֹܸ
	GPIO_DigitalRemapConfig(AFIOA, GPIO_Pin_6, AFIO_AF_1, ENABLE);	//SPI_MISOֹܸ
	GPIO_DigitalRemapConfig(AFIOA, GPIO_Pin_7, AFIO_AF_1, ENABLE);	//SPI_MOSIֹܸ
}

/**
* @brief SPIĹģʽ
* @param 
* @retval 
*/
void SPI_MasterMode_Config(void)
{
	SPI_InitTypeDef SPI_InitStructure;						 
	SPI_StructInit(&SPI_InitStructure);//ʹĬֵʼSPI_InitStructure

	/* SPI ģʽ */
	SPI_InitStructure.SPI_MasterSlaveMode = SPI_MasterSlaveMode_Master;//Ϊģʽ
	SPI_InitStructure.SPI_DataFrameFormat = SPI_DataFrameFormat_8b;//֡
	SPI_InitStructure.SPI_ClockPolarity = SPI_ClockPolarity_High;//ʱӼԣ״̬ʱSCKָߵƽ
	SPI_InitStructure.SPI_ClockPhase = SPI_ClockPhase_2Edge;//ʱλݲӵڶʱӱؿʼ
	SPI_InitStructure.SPI_CSS = SPI_CSS_SoftwareControl;//CSƣĬϳʼֵΪߵƽ
	SPI_InitStructure.SPI_Prescaler = 0;//SPIʱӷƵϵ
	SPI_InitStructure.SPI_BaudRate = 16;//SPIԤƵ f(sck)=f(pclk)/(SPI_Prescaler*(1+SPI_Prescaler))
	
	SPI_Init(SPI0, &SPI_InitStructure);//ʼSPI
	SPI_SoftwareControlCSSConfig(SPI0, SPI_SoftwareControlCSS_High);//ƬѡźſƣCSߵƽ

	SPI_ReceiveDMACmd(SPI0,ENABLE);
	SPI_SetDMATC(SPI0,SPI_DMA_TriggerControl_1);

	SPI_Cmd(SPI0, ENABLE);//ʹSPI
}

/**
* @brief SPI
* @param 
* @retval 
*/
void SPI_Driver(void)
{
	SPI_GPIO_Config();
	SPI_MasterMode_Config();
}

int main (void)
{
	u8 i = 0;
	u8 flag = 0;
  /*UART*/
	UART_Driver();
	/*SPI*/
	SPI_Driver();
	/*DMA*/
	DMA_Mode_Config();
	/*SPI*/
	for(i=0;i<10;i++)
	{
		SPI_SendData(SPI0,SPI0_TX_Buf[i]);
		Software_Delay();
	}
	while(1)
	{
		if((DMA_GetNumberOfData(DMA_Channel0) == 0)&&(flag == 0))
		{
			for(i=0;i<10;i++)
			{
				printf("SPI0_VAL[%d] = %d\r\n",i,SPI0_VAL[i]);
			}
			DMA_Cmd(DMA_Channel0,DISABLE);
			flag = 1;
		}
	} 
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(u8* file, u32 line)
{
	/* User can add his own implementation to report the file name and line number,
	   ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
	printf("Wrong parameters value: file %s on line %d\r\n", file, line);
	/* Infinite loop */
	while (1)
	{
	}
}
#endif
