/******************************************************************************
  * @Example PT32x076_DMA
  * @author  ӦÿŶ
  * @version V1.0.0
  * @date    2023/7/15
  * @brief   ͨDMAڴ浽ڴ淽򣬲ͨڴӡϢ
  *          
  ******************************************************************************
  * @attention	Ϊ96001λֹͣλżУ
  *
	* ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣
  * ̼/ͻʹаıϢκ, * Pai-IC κֱӣ ӻ̷𺦸
  *
  * (C) Ȩ Pai-IC Microelectronics
  *
  *****************************************************************************/
	
#include "PT32x076.h"

u16 DMA_TX_BUF[10] = {1,2,3,4,5,6,7,8,9,10};
u16 DMA_RX_BUF[10] = {0};

/**
* @brief DMAģʽ
* @param 
* @retval 
*/
void DMA_Mode_Config(void)
{
	DMA_InitTypeDef DMA_InitStruct;

	DMA_StructInit(&DMA_InitStruct);

	DMA_InitStruct.DMA_SourceBaseAddress = (u32)DMA_TX_BUF;//Դַ
	DMA_InitStruct.DMA_DestinationBaseAddress = (u32)DMA_RX_BUF;//Ŀĵַ
	DMA_InitStruct.DMA_NumberOfData = 10;//Ҫݵ
	DMA_InitStruct.DMA_SourceDataSize = DMA_SourceDataSize_Half;//ԴDMAĴݿ
	DMA_InitStruct.DMA_DestinationDataSize = DMA_DestinationDataSize_Half;//DMAĿĵصĴݿ
	DMA_InitStruct.DMA_SourceAddressIncrement = DMA_SourceAddressIncrement_Enable;//DMAԴַ
	DMA_InitStruct.DMA_DestinationAddressIncrement = DMA_DestinationAddressIncrement_Enable;//DMAĿĵַ
	DMA_InitStruct.DMA_Direction = DMA_Direction_MemoryToMemory;//䷽
	DMA_InitStruct.DMA_CircularMode = DMA_CircularMode_Disable;//ѭģʽ

	DMA_Init(DMA_Channel0,&DMA_InitStruct);//ʼDMA

	DMA_Cmd(DMA_Channel0,ENABLE);//ʹ
}

/**
* @brief UARTĸ
* @param 
* @retval 
*/
void UART_GPIO_Config(void)
{
	/* UARTܽŵĸù */
	GPIO_DigitalRemapConfig(AFIOA, GPIO_Pin_2, AFIO_AF_2, ENABLE);	//PA2 TX
	GPIO_DigitalRemapConfig(AFIOA, GPIO_Pin_3, AFIO_AF_2, ENABLE);	//PA3 RX
}

/**
* @brief UARTĹģʽ
* @param 
* @retval 
*/
void UART_Mode_Config(void)
{
	UART_InitTypeDef  UART_InitStruct;
	
	/*ʼUART0*/
	UART_InitStruct.UART_BaudRate = 9600;
	UART_InitStruct.UART_DataLength = UART_DataLength_8;
	UART_InitStruct.UART_StopBitLength = UART_StopBitLength_1;
	UART_InitStruct.UART_ParityMode = UART_Parity_None;
	UART_InitStruct.UART_Receiver = UART_Receiver_Enable;
	UART_Init(UART0, &UART_InitStruct);

	/*ʹUART0*/
	UART_Cmd(UART0, ENABLE);
}

/**
* @brief UART
* @param 
* @retval 
*/
void UART_Driver(void)
{
	UART_GPIO_Config();
	UART_Mode_Config();
}

int main (void)
{
	u8 i = 0;
	u8 flag = 0;
	/*UART*/
  UART_Driver();
  /*DMA*/
	DMA_Mode_Config();
	while(1)
	{
		if((DMA_GetNumberOfData(DMA_Channel0) == 0)&&(flag == 0))
		{
			for(i=0;i<10;i++)
			{
				printf("DMA_RX_BUF[%d] = %d\r\n",i,DMA_RX_BUF[i]);
			}
			DMA_Cmd(DMA_Channel0,DISABLE);
			flag = 1;
		}
	}  
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(u8* file, u32 line)
{
	/* User can add his own implementation to report the file name and line number,
	   ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
	printf("Wrong parameters value: file %s on line %d\r\n", file, line);
	/* Infinite loop */
	while (1)
	{
	}
}
#endif
