/******************************************************************************
  * @Example PT32x076_CMP
  * @author  ӦÿŶ
  * @version V1.0.0
  * @date    2023/7/15
  * @brief   ȽCOMP3ĸΪLDACɵ0.5VddѹΪPC3ͨʱɵķ룬
	*          COMP3_OUT(PF3)PC3Եź,ػ½أRGBƻ˸û轫PC5PC4CMP3_P0ͨñ̽ӡ
  *          
  ******************************************************************************
  * @attention	Ϊ96001λֹͣλżУ
  *
	* ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣
  * ̼/ͻʹаıϢκ, * Pai-IC κֱӣ ӻ̷𺦸
  *
  * (C) Ȩ Pai-IC Microelectronics
  *
  *****************************************************************************/
	
#include "PT32x076.h"

#define		B_LED_PORT		GPIOA
#define		B_LED_PIN		  GPIO_Pin_10

#define		G_LED_PORT		GPIOA
#define		G_LED_PIN		  GPIO_Pin_11

/**
* @brief ʱ
* @param 
* @retval 
*/
void Software_Delay(void)
{
	u8 i, j,x;
	for(i=0; i<200; i++)
		for(j=0; j<200; j++)
			for(x=0; x<20; x++);
}

/**
* @brief PWM
* @param 
* @retval 
*/
void Software_PWM_Driver(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;							//һGPIO_InitTypeDef͵Ľṹ
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_5;					//ѡҪƵGPIO
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OutPP;		//ģʽΪͨ
	GPIO_InitStructure.GPIO_Pull = GPIO_Pull_NoPull;	//ƫ
	GPIO_Init(GPIOC, &GPIO_InitStructure);						//ÿ⺯ʼGPIO
}

/**
* @brief PWM
* @param 
* @retval 
*/
void Software_PWM_Run(void)
{
		static u8 count_temp=0;
		count_temp++;
		if(count_temp==1)		//
		{
			GPIO_SetBits(GPIOC, GPIO_Pin_5);
		}
		if(count_temp==2)		//½
		{
			count_temp=0;
			GPIO_ResetBits(GPIOC, GPIO_Pin_5);
		}
}

void LDAC_Driver(void)
{
	LDAC_SetData(LDAC,0x3F);
	LDAC_Cmd(LDAC,ENABLE);	
}

/**
* @brief COMP
* @param 
* @retval 
*/
void COMP_GPIO_Config(void)
{	
	GPIO_AnalogRemapConfig(AFIOA, GPIO_Pin_12,ENABLE); 	//CMP3_Nͨ	
	GPIO_AnalogRemapConfig(AFIOC, GPIO_Pin_4,ENABLE); 	//CMP3_P0ͨ	
	GPIO_DigitalRemapConfig(AFIOF, GPIO_Pin_3, AFIO_AF_6, ENABLE);	//ΪCMP3_OUTͨ	
}

/**
* @brief COMPʽ
* @param 
* @retval 
*/
void COMP_Int_Config(void)
{
	CMP_InitTypeDef CMP_InitStruct;
	NVIC_InitTypeDef NVIC_InitStruct;
	
	CMP_StructInit(&CMP_InitStruct);
	CMP_InitStruct.CMP_NegativeInput = CMP_NegativeInput_LDAC;//CMPѡLDAC
	CMP_InitStruct.CMP_DigitalFilter = CMP_DigitalFilter_None;//˲
	CMP_InitStruct.CMP_PowerMode = CMP_PowerMode_HighSpeed;//ѡģʽ
	CMP_InitStruct.CMP_OutputPolarity = CMP_OutputPolarity_Normal;//ѡ
	CMP_InitStruct.CMP_PositiveInput= CMP_PositiveInput_CMPxP0;//CMPѡP0
	CMP_InitStruct.CMP_InitializationDelayTime = 0x00;
	CMP_Init(CMP3,&CMP_InitStruct);
	
	CMP_ITConfig(CMP3,CMP_IT_COF|CMP_IT_COR,ENABLE);
	NVIC_InitStruct.NVIC_IRQChannel = CMP_IRQn;
	NVIC_InitStruct.NVIC_IRQChannelPriority = 0x00;
	NVIC_InitStruct.NVIC_IRQChannelCmd = ENABLE;
	NVIC_Init(&NVIC_InitStruct);
	
	CMP_Cmd(CMP3,ENABLE);
}

/**
* @brief COMP
* @param 
* @retval 
*/
void COMP_Driver(void)
{
	COMP_GPIO_Config();
	COMP_Int_Config();
}

/**
* @brief LED
* @param 
* @retval 
*/
void LED_Driver(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;	//һGPIO_InitTypeDef͵Ľṹ
	GPIO_InitStructure.GPIO_Pin = G_LED_PIN;	//ѡҪƵGPIO
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OutPP;		//ģʽΪͨ
	GPIO_InitStructure.GPIO_Pull = GPIO_Pull_Up;	//ƫ
	GPIO_Init(G_LED_PORT, &GPIO_InitStructure);	//ÿ⺯ʼGPIO
	
	GPIO_InitStructure.GPIO_Pin = B_LED_PIN;
	GPIO_Init(B_LED_PORT, &GPIO_InitStructure);	//ÿ⺯ʼGPIO
	
	GPIO_SetBits(B_LED_PORT, B_LED_PIN);			//ÿ⺯GPIO״̬
	GPIO_SetBits(G_LED_PORT, G_LED_PIN);			//ÿ⺯GPIO״̬
}

int main (void)
{
	Software_PWM_Driver();
	LED_Driver();
	COMP_Driver();
	LDAC_Driver();
	while(1)
	{
		Software_Delay();
		Software_PWM_Run();
		Software_Delay();
	}
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(u8* file, u32 line)
{
	/* User can add his own implementation to report the file name and line number,
	   ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
	printf("Wrong parameters value: file %s on line %d\r\n", file, line);
	/* Infinite loop */
	while (1)
	{
	}
}
#endif
