/******************************************************************************
  * @Example PT32x076_I2C
  * @author  ӦÿŶ
  * @version V1.0.0
  * @date    2023/7/15
  * @brief   ͨI2C԰EEPROMдݲȡϢͨڴӡ
  *          
  ******************************************************************************
  * @attention	Ϊ96001λֹͣλżУ
  *
	* ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣
  * ̼/ͻʹаıϢκ, * Pai-IC κֱӣ ӻ̷𺦸
  *
  * (C) Ȩ Pai-IC Microelectronics
  *
  *****************************************************************************/
	
#include "PT32x076.h"

/**
* @brief ʱ
* @param 
* @retval 
*/
void Software_Delay(void)
{
	u8 i, j,x;
	for(i=0; i<200; i++)
		for(j=0; j<200; j++)
			for(x=0; x<20; x++);
}

/**
* @brief UARTĸ
* @param 
* @retval 
*/
void UART_GPIO_Config(void)
{
	/* UARTܽŵĸù */
	GPIO_DigitalRemapConfig(AFIOA, GPIO_Pin_2, AFIO_AF_2, ENABLE);	//PA2 TX
	GPIO_DigitalRemapConfig(AFIOA, GPIO_Pin_3, AFIO_AF_2, ENABLE);	//PA3 RX
}

/**
* @brief UARTĹģʽ
* @param 
* @retval 
*/
void UART_Mode_Config(void)
{
	UART_InitTypeDef  UART_InitStruct;
	
	/*ʼUART0*/
	UART_InitStruct.UART_BaudRate = 9600;
	UART_InitStruct.UART_DataLength = UART_DataLength_8;
	UART_InitStruct.UART_StopBitLength = UART_StopBitLength_1;
	UART_InitStruct.UART_ParityMode = UART_Parity_None;
	UART_InitStruct.UART_Receiver = UART_Receiver_Enable;
	UART_Init(UART0, &UART_InitStruct);

	/*ʹUART0*/
	UART_Cmd(UART0, ENABLE);
}

/**
* @brief UART
* @param 
* @retval 
*/
void UART_Driver(void)
{
	UART_GPIO_Config();
	UART_Mode_Config();
}

/**
* @brief I2Cĸ
* @param 
* @retval 
*/
void I2C_GPIO_Config(void)
{
	/* I2Cܽŵĸù */
	GPIO_DigitalRemapConfig(AFIOF, GPIO_Pin_7, AFIO_AF_0, ENABLE);	//PF7 I2C0 SDA
	GPIO_DigitalRemapConfig(AFIOF, GPIO_Pin_6, AFIO_AF_0, ENABLE);	//PF6 I2C0 SCL
}

/**
* @brief I2CĹģʽ
* @param 
* @retval 
*/
void I2C_Mode_Config(void)
{  
	I2C_InitTypeDef I2C_InitStruct;
	I2C_InitStruct.I2C_Acknowledge = I2C_Acknowledge_Disable;
	I2C_InitStruct.I2C_Broadcast = I2C_Broadcast_Disable;
	I2C_InitStruct.I2C_OwnAddress = 0x00;
	I2C_InitStruct.I2C_Prescaler = 32;
	I2C_Init(I2C0,&I2C_InitStruct);   
}

/**
* @brief I2C
* @param 
* @retval 
*/
void I2C_Driver(void)
{
	I2C_GPIO_Config();
	I2C_Mode_Config();
}

/**
* @brief I2Cд
* @param pBufferҪд
* @param WriteAddrӻַ
* @param NumByteToWriteҪдݳ
* @retval 
*/
void I2C_EE_Write(uint8_t* pBuffer, unsigned int WriteAddr,uint16_t DeviceAddr, uint16_t data_size)
{
	int i;
/******************ȴӻready***************/		
	I2C_GenerateEvent(I2C0,I2C_Event_Start,DISABLE);
	I2C0->CCR |= I2C_CCR_SI | I2C_CCR_ACK;
	I2C_Cmd(I2C0,DISABLE);
	I2C_Cmd(I2C0,ENABLE);
	I2C_GenerateEvent(I2C0,I2C_Event_Start,ENABLE);	
	while(I2C_GetFlagStatus(I2C0,I2C_FLAG_StartOk)!= SET);
	I2C_SendAddress(I2C0, DeviceAddr);//ַд
	while(I2C_GetFlagStatus(I2C0,I2C_FLAG_MASGetAckW)!=SET);
	I2C_SendData(I2C0,WriteAddr);//Ҫдֵַ
	while(I2C_GetFlagStatus(I2C0,I2C_FLAG_MDSGetAck)!=SET);
	I2C_SendData(I2C0,WriteAddr);//Ҫдֵַ
	while(I2C_GetFlagStatus(I2C0,I2C_FLAG_MDSGetAck)!=SET);
	for(i=0;i<data_size;i++)
	{
		I2C_SendData(I2C0, *pBuffer);
		while(I2C_GetFlagStatus(I2C0,I2C_FLAG_MDSGetAck) != SET);
		pBuffer++;
	}
		/******************ֹͣλ***************/
	I2C_GenerateEvent(I2C0,I2C_Event_Stop,ENABLE);	
}

/**
* @brief I2C
* @param pBuffer
* @param ReadAddrӻַ
* @param NumByteToReadݳ
* @retval 
*/
void I2C_EE_Read(uint8_t* pBuffer,uint16_t ReadAddr, uint16_t DeviceAddr, uint16_t data_size)
{
	int i;
/******************ȴӻready***************/		
	I2C_GenerateEvent(I2C0,I2C_Event_Start,ENABLE);
	while(I2C_GetFlagStatus(I2C0,I2C_FLAG_StartOk)!= SET);
	I2C_SendAddress(I2C0, DeviceAddr);//ַд
	while(I2C_GetFlagStatus(I2C0,I2C_FLAG_MASGetAckW)!=SET);
	I2C_SendData(I2C0,ReadAddr);//Ҫҳַ
	while(I2C_GetFlagStatus(I2C0,I2C_FLAG_MDSGetAck)!=SET);
	I2C_SendData(I2C0,ReadAddr);//Ҫҳַ
	while(I2C_GetFlagStatus(I2C0,I2C_FLAG_MDSGetAck)!=SET);
	I2C_GenerateEvent(I2C0,I2C_Event_Stop,ENABLE);
/*********************************/		
	I2C_GenerateEvent(I2C0,I2C_Event_Start,ENABLE);
	while(I2C_GetFlagStatus(I2C0,I2C_FLAG_StartOk)!= SET);
	I2C_SendAddress(I2C0, DeviceAddr|0x01);//ַ
	while(I2C_GetFlagStatus(I2C0,I2C_FLAG_MASGetAckR)!=SET);
	for(i=0;i<data_size;i++)
	{
		I2C0->CCR=0x8;
		while(I2C_GetFlagStatus(I2C0,I2C_FLAG_MDGSendAck) != SET);
		*pBuffer=I2C_ReceiveData(I2C0);
		pBuffer++;
	}
	/******************ֹͣλ***************/
	I2C_GenerateEvent(I2C0,I2C_Event_Stop,ENABLE);
}

u8 arry_write[10]={0,1,2,3,4,5,6,7,8,9};
u8 arry_read[10]={0};
int main (void)
{
  int i=0;
	u8 addr=0x0;
	
	UART_Driver();
	I2C_Driver();
	printf("I2C start to write\r\n");
	I2C_EE_Write(arry_write, addr,0xA0, sizeof(arry_write));
	printf("I2CдEEPROMݣ\r\n");
	for(i=0;i<sizeof(arry_write);i++)
	{
		printf(" %d ",arry_write[i]);
	}
	printf("\r\n");
	printf("I2C start to read\r\n");
	I2C_EE_Read(arry_read,addr,0xA0,sizeof(arry_read));
	printf("I2CȡEEPROMݣ\r\n");
	for(i=0;i<sizeof(arry_read);i++)
	{
		printf(" %d ",arry_read[i]);
	}
	printf("\r\n");
	while(1)
	{
		
	}
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(u8* file, u32 line)
{
	/* User can add his own implementation to report the file name and line number,
	   ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
	printf("Wrong parameters value: file %s on line %d\r\n", file, line);
	/* Infinite loop */
	while (1)
	{
	}
}
#endif
