/******************************************************************************
  * @Example PT32x076_SPI
  * @author  ӦÿŶ
  * @version V1.0.0
  * @date    2023/7/15
  * @brief   ȶ԰Nor FlashоƬеһζȡд룻дݣڶζ
  *          
  ******************************************************************************
  * @attention	Ϊ96001λֹͣλżУ
  *
	* ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣
  * ̼/ͻʹаıϢκ, * Pai-IC κֱӣ ӻ̷𺦸
  *
  * (C) Ȩ Pai-IC Microelectronics
  *
  *****************************************************************************/
	
#include "PT32x076.h"
#include "spi_flash.h"

/**
* @brief ʱ
* @param 
* @retval 
*/
void Software_Delay(void)
{
	u8 i, j,x;
	for(i=0; i<200; i++)
		for(j=0; j<200; j++)
			for(x=0; x<20; x++);
}

/**
* @brief UARTĸ
* @param 
* @retval 
*/
void UART_GPIO_Config(void)
{
	/* UARTܽŵĸù */
	GPIO_DigitalRemapConfig(AFIOA, GPIO_Pin_2, AFIO_AF_2, ENABLE);	//PA2 TX
	GPIO_DigitalRemapConfig(AFIOA, GPIO_Pin_3, AFIO_AF_2, ENABLE);	//PA3 RX
}

/**
* @brief UARTĹģʽ
* @param 
* @retval 
*/
void UART_Mode_Config(void)
{
	UART_InitTypeDef  UART_InitStruct;
	
	/*ʼUART0*/
	UART_InitStruct.UART_BaudRate = 9600;
	UART_InitStruct.UART_DataLength = UART_DataLength_8;
	UART_InitStruct.UART_StopBitLength = UART_StopBitLength_1;
	UART_InitStruct.UART_ParityMode = UART_Parity_None;
	UART_InitStruct.UART_Receiver = UART_Receiver_Enable;
	UART_Init(UART0, &UART_InitStruct);

	/*ʹUART0*/
	UART_Cmd(UART0, ENABLE);
}

/**
* @brief UART
* @param 
* @retval 
*/
void UART_Driver(void)
{
	UART_GPIO_Config();
	UART_Mode_Config();
}

/**
* @brief SPIĸ
* @param 
* @retval 
*/
void SPI_GPIO_Config(void)
{
	GPIO_DigitalRemapConfig(AFIOA, GPIO_Pin_4, AFIO_AF_1,ENABLE);	//SPI_CSֹܸ
	GPIO_DigitalRemapConfig(AFIOA, GPIO_Pin_5, AFIO_AF_1,ENABLE);	//SPI_SCKֹܸ
	GPIO_DigitalRemapConfig(AFIOA, GPIO_Pin_6, AFIO_AF_1,ENABLE);	//SPI_MIS0ֹܸ
	GPIO_DigitalRemapConfig(AFIOA, GPIO_Pin_7, AFIO_AF_1,ENABLE);	//SPI_MOSIֹܸ
}

/**
* @brief SPIĹģʽ
* @param 
* @retval 
*/
void SPI_MasterMode_Config(void)
{
	SPI_InitTypeDef  SPI_InitStructure;//һSPI_InitTypeDef͵Ľṹ
	SPI_StructInit(&SPI_InitStructure);//ʹĬֵʼSPI_InitStructure
	
  SPI_InitStructure.SPI_MasterSlaveMode=SPI_MasterSlaveMode_Master;//Ϊģʽ
  SPI_InitStructure.SPI_DataFrameFormat=SPI_DataFrameFormat_8b;//֡
  SPI_InitStructure.SPI_ClockPolarity=SPI_ClockPolarity_High;//ʱӼԣ״̬ʱSCKָߵƽ
	SPI_InitStructure.SPI_ClockPhase=SPI_ClockPhase_2Edge;//ʱλݲӵڶʱӱؿʼ
	SPI_InitStructure.SPI_CSS = SPI_CSS_SoftwareControl;//CSƣĬϳʼֵΪߵƽ
	SPI_InitStructure.SPI_Prescaler = 0;//SPIʱӷƵϵ
  SPI_InitStructure.SPI_BaudRate=16; //SPIԤƵ f(sck)=f(pclk)/(SPI_Prescaler*(1+SPI_Prescaler))
	SPI_Init(SPI0, &SPI_InitStructure);//ʼSPI
	SPI_Cmd(SPI0, ENABLE);//ʹSPI
}

/**
* @brief SPI
* @param 
* @retval 
*/
void SPI_Driver(void)
{
	SPI_GPIO_Config();
	SPI_MasterMode_Config();
}

/**
* @brief Nor Flashֽڷͺ
* @param 
* @retval 
*/
uint8_t FLASH_SendByte(SPI_TypeDef* SPIx,uint8_t byte)
{
	u16 SPITimeout;
	SPITimeout = SPIT_FLAG_TIMEOUT;
  /* ȴͻΪգTXE¼ */
	while((SPI0->SR1&SPI_SR1_TXE)==0)
	{
    if((SPITimeout--) == 0)   
		{
			FLASH_ERROR("SPI ȴʱ!errorCode = %d",0);
		}
  }
  /* дݼĴҪдд뷢ͻ */
  SPI_SendData(SPIx , byte);

	SPITimeout = SPIT_FLAG_TIMEOUT;
  /* ȴջǿգRXNE¼ */
	while((SPI0->SR1&SPI_SR1_RXNE)==0)
	{
    if((SPITimeout--) == 0)   
		{
			FLASH_ERROR("SPI ȴʱ!errorCode = %d",1);
		}
   }
  /* ȡݼĴȡջ */
  return SPI_ReceiveData(SPIx );
}

/**
* @brief Nor FlashȡID
* @param 
* @retval 
*/
uint32_t FLASH_ReadID(SPI_TypeDef* SPIx)
{
  uint32_t Temp = 0, Temp0 = 0, Temp1 = 0, Temp2 = 0;
  /* ʼͨѶCS͵ƽ */   
	SPI_SoftwareControlCSSConfig(SPIx,SPI_SoftwareControlCSS_Low);
  /* JEDECָȡID */
  FLASH_SendByte(SPIx,W25X_JedecDeviceID);
  /* ȡһֽ */
  Temp0 = FLASH_SendByte(SPIx,0x00);
  /* ȡһֽ */
  Temp1 = FLASH_SendByte(SPIx,0x00);
  /* ȡһֽ */
  Temp2 = FLASH_SendByte(SPIx,0x00);
 /* ֹͣͨѶCSߵƽ */
  SPI_SoftwareControlCSSConfig(SPIx,SPI_SoftwareControlCSS_High);

  /*Ϊķֵ*/
	Temp = (Temp0 << 16) | (Temp1 << 8) | Temp2;
  return Temp;
}

/**
* @brief Nor Flashȡֽں
* @param 
* @retval 
*/
void Flash_ReadByte(SPI_TypeDef* SPIx,u32 addr)
{
	u8 data[10]={0},i;
	/* ʼͨѶCS͵ƽ */   
	SPI_SoftwareControlCSSConfig(SPIx,SPI_SoftwareControlCSS_Low);
  /* ָȡ */
  FLASH_SendByte(SPIx,W25X_ReadData);
  FLASH_SendByte(SPIx,(addr&0xFF0000)>>16);
  FLASH_SendByte(SPIx,(addr&0xFF00)>>8);
  FLASH_SendByte(SPIx,addr&0xFF);
	for(i=0;i<10;i++)
	{
  	data[i]=FLASH_SendByte(SPIx,Dummy_Byte);
	}
	printf("address: 0x%X\r\n",addr);
	for(i=0;i<10;i++)
	{
  	printf("read data%d:%X\r\n",i,data[i]);
		while(!UART_GetFlagStatus(UART0,UART_FLAG_TXE));
	}
  SPI_SoftwareControlCSSConfig(SPIx,SPI_SoftwareControlCSS_High);
}

/**
* @brief Nor Flash
* @param 
* @retval 
*/
void Flash_SectorErase(SPI_TypeDef* SPIx,u32 addr)
{
	//ִдʹ
	SPI_FLASH_WriteEnable(SPI0);
  //
	SPI_SoftwareControlCSSConfig(SPIx,SPI_SoftwareControlCSS_Low);
  FLASH_SendByte(SPIx,W25X_SectorErase);
  FLASH_SendByte(SPIx,(addr&0xFF0000)>>16);
  FLASH_SendByte(SPIx,(addr&0xFF00)>>8);
  FLASH_SendByte(SPIx,addr&0xFF);
	SPI_SoftwareControlCSSConfig(SPIx,SPI_SoftwareControlCSS_High);
	SPI_FLASH_WaitForWriteEnd(SPI0);
}

/**
* @brief Nor Flashֽд뺯
* @param 
* @retval 
*/
void Flash_WriteByte(SPI_TypeDef* SPIx,u32 addr)
{
	u8 i,data[10]={0};
	//ִдʹ
	SPI_FLASH_WriteEnable(SPI0);
	//д
	SPI_SoftwareControlCSSConfig(SPIx,SPI_SoftwareControlCSS_Low);
  FLASH_SendByte(SPIx,W25X_PageProgram);
  FLASH_SendByte(SPIx,(addr&0xFF0000)>>16);
  FLASH_SendByte(SPIx,(addr&0xFF00)>>8);
  FLASH_SendByte(SPIx,addr&0xFF);
	for(i=0;i<10;i++)
	{
		data[i]=i;
	  FLASH_SendByte(SPIx,data[i]);	
	}
  SPI_SoftwareControlCSSConfig(SPIx,SPI_SoftwareControlCSS_High);
	SPI_FLASH_WaitForWriteEnd(SPI0);
}

/**
* @brief Nor Flashдʹܺ
* @param 
* @retval 
*/
void FLASH_ReadWrite(SPI_TypeDef* SPIx,u32 addr)
{
	Flash_SectorErase(SPI0,addr);
	Flash_ReadByte(SPI0,addr);
	Flash_WriteByte(SPI0,addr);
	Flash_ReadByte(SPI0,addr);
}

int main (void)
{
	uint32_t DeviceID;
	UART_Driver();
	SPI_Driver();
	printf("ڶȡFlashϢ\r\n");
	Software_Delay();
	DeviceID = FLASH_ReadID(SPI0);
	printf("Device ID:%X\r\n",DeviceID);
	Software_Delay();
	FLASH_ReadWrite(SPI0,0x000);
	while(1)
	{
	
	}
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(u8* file, u32 line)
{
	/* User can add his own implementation to report the file name and line number,
	   ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
	printf("Wrong parameters value: file %s on line %d\r\n", file, line);
	/* Infinite loop */
	while (1)
	{
	}
}
#endif
