/******************************************************************************
  * @Example PT32x076_RTC
  * @author  ӦÿŶ
  * @version V1.0.0
  * @date    2023/7/15
  * @brief   3RTCӣÿ3ӽһRTCжϣͨLED̵ʵ3˸һεĹ
  *          
  ******************************************************************************
  * @attention	Ϊ96001λֹͣλżУ
  *
	* ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣
  * ̼/ͻʹаıϢκ, * Pai-IC κֱӣ ӻ̷𺦸
  *
  * (C) Ȩ Pai-IC Microelectronics
  *
  *****************************************************************************/
	
#include "PT32x076.h"

/**
  * @brief  LED
  * @param  
  * @retval 
  */
void LED_Driver(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;	//һGPIO_InitTypeDef͵Ľṹ
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_12;	//ѡҪƵGPIO
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OutPP;		//ģʽΪͨ
	GPIO_InitStructure.GPIO_Pull = GPIO_Pull_NoPull;	//ƫ
	GPIO_Init(GPIOC, &GPIO_InitStructure);	//ÿ⺯ʼGPIO
	GPIO_ResetBits(GPIOC, GPIO_Pin_12);			//ÿ⺯GPIO״̬
}

/**
  * @brief  RTCж
	* @note	  ʹRTCж
  * @param  
  * @retval 
  */
void RTC_Int_Diver(void)
{
	NVIC_InitTypeDef NVIC_InitStruct;
	NVIC_InitStruct.NVIC_IRQChannel= RTC_IRQn;								//ʱжԴ
	NVIC_InitStruct.NVIC_IRQChannelPriority = 0x00;							//жȼ
	NVIC_InitStruct.NVIC_IRQChannelCmd =ENABLE;								//ʹNVIC
	NVIC_Init(&NVIC_InitStruct);	
	/*Ϊ3*/
	RTC_PeriodInterval(5);	
	/*жʹ*/
	RTC_ITConfig(RTC_IT_PEDE,ENABLE);	
}

/**
  * @brief  RTC
	* @note   RTCʱʽԼǰʱ
	* @note   LSEΪRTCʱԴʱʱҪʹLSE
  * @param  
  * @retval 
  */
void RTC_Driver(void)
{
	RTC_InitTypeDef RTC_InitStruct;
	RTC_Calendar CalendarTime;
	RTC_InitStruct.RTC_BeaconOut = RTC_BeaconOut_DISABLE;
	RTC_InitStruct.RTC_ClkSource = RTC_ClkSource_LSE;
	RTC_InitStruct.RTC_TF = RTC_TimeFormat_24;
	RTC_InitStruct.RTC_TrimMode = RTC_TrimMode_DISABLE;
  RTC_Init(&RTC_InitStruct);
	CalendarTime.TimeFormat = RTC_TimeFormat_24;
	CalendarTime.PM = RTC_HOUR_AM;
	CalendarTime.Second = 1;
	CalendarTime.Minute = 2;
	CalendarTime.Hour = 3;
	CalendarTime.Day = 4;
	CalendarTime.Week = 5;
	CalendarTime.Year = 2023;
	CalendarTime.Month = 6;
	RTC_SetCalendarTime(&CalendarTime);
	RTC_Int_Diver();
	/*ʹRTC*/
	RTC_Cmd(ENABLE);
}

/**
* @brief ʱ
* @param 
* @retval 
*/
void Software_Delay(void)
{
	u8 i, j,x;
	for(i=0; i<200; i++)
		for(j=0; j<200; j++)
			for(x=0; x<20; x++);
}


int main (void)
{
	RCC_AdvancedSoftwareReset(RCC_AdvancedSoftwareReset_RTC);
	LED_Driver();
	RTC_Driver();
  while(1)
	{
		
	}
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(u8* file, u32 line)
{
	/* User can add his own implementation to report the file name and line number,
	   ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
	printf("Wrong parameters value: file %s on line %d\r\n", file, line);
	/* Infinite loop */
	while (1)
	{
	}
}
#endif
