/******************************************************************************
  * @Example PT32x076_LCD
  * @author  ӦÿŶ
  * @version V1.0.0
  * @date    2023/7/15
  * @brief   ͨLCDLCDʾĻʾ֡4797
  *          
  ******************************************************************************
  * @attention	Ϊ96001λֹͣλżУ
  *
	* ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣
  * ̼/ͻʹаıϢκ, * Pai-IC κֱӣ ӻ̷𺦸
  *
  * (C) Ȩ Pai-IC Microelectronics
  *
  *****************************************************************************/
	
#include "PT32x076.h"

#define Display_Page 0

#define   LcdSeg_a		0x01
#define   LcdSeg_b		0x10
#define   LcdSeg_f		0x02
#define   LcdSeg_g		0x20
#define   LcdSeg_e		0x04
#define   LcdSeg_c		0x40
#define   LcdSeg_p		0x08
#define   LcdSeg_d		0x80
#define		Char_0		LcdSeg_a+LcdSeg_b+LcdSeg_c+LcdSeg_d+LcdSeg_e+LcdSeg_f
#define  	Char_1		LcdSeg_b+LcdSeg_c
#define		Char_2		LcdSeg_a+LcdSeg_b+LcdSeg_d+LcdSeg_e+LcdSeg_g
#define		Char_3		LcdSeg_a+LcdSeg_b+LcdSeg_c+LcdSeg_d+LcdSeg_g
#define		Char_4		LcdSeg_b+LcdSeg_c+LcdSeg_f+LcdSeg_g
#define		Char_5		LcdSeg_a+LcdSeg_c+LcdSeg_d+LcdSeg_f+LcdSeg_g
#define		Char_6		LcdSeg_a+LcdSeg_g+LcdSeg_c+LcdSeg_d+LcdSeg_e+LcdSeg_f
#define		Char_7		LcdSeg_a+LcdSeg_b+LcdSeg_c
#define		Char_8		LcdSeg_a+LcdSeg_b+LcdSeg_c+LcdSeg_d+LcdSeg_e+LcdSeg_f+LcdSeg_g
#define		Char_9		LcdSeg_a+LcdSeg_b+LcdSeg_c+LcdSeg_d+LcdSeg_f+LcdSeg_g
#define		Char_A		LcdSeg_a+LcdSeg_b+LcdSeg_c+LcdSeg_e+LcdSeg_f+LcdSeg_g
#define		Char_B 		LcdSeg_c+LcdSeg_d+LcdSeg_e+LcdSeg_f+LcdSeg_g
#define		Char_C 		LcdSeg_a+LcdSeg_f+LcdSeg_e+LcdSeg_d
#define		Char_D		LcdSeg_b+LcdSeg_c+LcdSeg_d+LcdSeg_e+LcdSeg_g
#define		Char_E		LcdSeg_a+LcdSeg_d+LcdSeg_e+LcdSeg_f+LcdSeg_g
#define		Char_F		LcdSeg_a+LcdSeg_f+LcdSeg_e+LcdSeg_g
#define		Char_r    LcdSeg_e+LcdSeg_g
#define		Char_H	 	LcdSeg_b+LcdSeg_c+LcdSeg_e+LcdSeg_f+LcdSeg_g
#define 	Char_L    LcdSeg_d+LcdSeg_e+LcdSeg_f
#define 	Char_Row	LcdSeg_g
#define 	Char_U		LcdSeg_b+LcdSeg_c+LcdSeg_d+LcdSeg_e+LcdSeg_f

u8 Display_Char_Table[21] =
{
	Char_0,
	Char_1,
	Char_2,
	Char_3,
	Char_4,
	Char_5,
	Char_6,
	Char_7,
	Char_8,
	Char_9,
	Char_A,
	Char_B,
	Char_C,
	Char_D,
	Char_E,
	Char_F,
	Char_r,
	Char_H,
	Char_L,
	Char_Row,
	Char_U
};

/**
  * @brief  תΪɹLCDȡʾĸʽ
  * @param  Dis_Data: 0~20ʾLCDʾ֣οDisplay_Char_Table
  * @retval Get_Table_Dataתɵ
  */
u8 Get_Dis_Format(u8 Dis_data)
{
	u8 Get_Table_Data;
	Get_Table_Data = Display_Char_Table[Dis_data];
	return Get_Table_Data;
}

/**
  * @brief  ָݷ͵LCDӦPageĴ
  * @param  Dis_BIT: 1~4ʾDEMOLCDʾλ
  * @param  Dis_Data: 0~20ʾLCDʾ֣οDisplay_Char_Table
  * @param  Page: 0~15LCDʾĴ16ҳ
  * @retval None
  */
void Buff_Dis_Data_To_Page(u8 Dis_BIT,u8 Dis_Data,u8 Page)
{
	u8 addr_offset=0;
	u8 low_offset=0,high_offset=0;
	u16 Bit16_Low_Byte, Bit16_High_Byte;
	u32 And_Data=0;
	
	Bit16_Low_Byte  =  Dis_Data & 0x0F;
	Bit16_High_Byte  =  Dis_Data >> 4;

	if(Dis_BIT==1||Dis_BIT==3)
	{
		low_offset=0;
		high_offset=8;
		And_Data=0xFFFF0000;
	}
	else if(Dis_BIT==2||Dis_BIT==4)
	{
		low_offset=16;
		high_offset=24;
		And_Data=0x0000FFFF;
	}
	
	if(Dis_BIT==1||Dis_BIT==2)
	{
		addr_offset=0x01;
		LCD->LCD_PxLy[Page*LCD_PAGE_REGS+addr_offset]&=And_Data;
		LCD->LCD_PxLy[Page*LCD_PAGE_REGS+addr_offset]|=(Bit16_High_Byte << high_offset) | (Bit16_Low_Byte<<low_offset);
	}
	else if(Dis_BIT==3||Dis_BIT==4)
	{
		addr_offset=0x02;
		LCD->LCD_PxLy[Page*LCD_PAGE_REGS+addr_offset]&=And_Data;
		LCD->LCD_PxLy[Page*LCD_PAGE_REGS+addr_offset]|=(Bit16_High_Byte << high_offset) | (Bit16_Low_Byte << low_offset);
	}
}

/**
  * @brief  ָҺϣʾָ
  * @note   
  * @param  Dis_BIT: 1~4ʾDEMOLCDʾλ
  * @param  Dis_Data: 0~20ʾLCDʾ֣οDisplay_Char_Table
  *        
  * @retval None
  */
void Display_number(u8 Dis_BIT,u8 Dis_Data,u8 Dis_Page)
{
	Dis_Data=Get_Dis_Format(Dis_Data);
	Buff_Dis_Data_To_Page(Dis_BIT,Dis_Data,Dis_Page);
}

/**
  * @brief  LCDģ⹦ʹ
  * @param         
  * @retval None
  */
void LCD_GPIO_Config(void)
{
	GPIO_AnalogRemapConfig(AFIOA, GPIO_Pin_8,ENABLE);
	GPIO_AnalogRemapConfig(AFIOC, GPIO_Pin_9|GPIO_Pin_8|GPIO_Pin_7|GPIO_Pin_6, ENABLE);
	GPIO_AnalogRemapConfig(AFIOB, GPIO_Pin_15|GPIO_Pin_14|GPIO_Pin_13|GPIO_Pin_12|GPIO_Pin_11|GPIO_Pin_10,ENABLE);
	GPIO_AnalogRemapConfig(AFIOF, GPIO_Pin_2,ENABLE);
}

/**
  * @brief  LCDΪ̶ҳʾ
  * @param   
  * @retval None
  */
void LCD_Mode_Config(void)
{
	LCD_InitTypeDef LCD_InitStruct;
	LCD_StructInit(&LCD_InitStruct);
	LCD_InitStruct.LCD_PageDisplayMode=LCD_PageDisplayMode_Fixed;	//̶ҳʾ
	LCD_Init(&LCD_InitStruct);
	LCD_PinConfig(LCD_PIN_0|LCD_PIN_1|LCD_PIN_2|LCD_PIN_3|LCD_PIN_4|LCD_PIN_5|LCD_PIN_6|LCD_PIN_7|LCD_PIN_8|LCD_PIN_9|LCD_PIN_10|LCD_PIN_11,ENABLE);
	LCD_PinDriverConfig(LCD_PIN_0|LCD_PIN_1|LCD_PIN_2|LCD_PIN_3,LCD_DRIVER_COM);				//LCD0~LCD3ΪCOM
	LCD_Prescaler(4);			//֡ˢƵ=32k/(4COM*2*(4FSEL*8+1))Լ120Hz
	LCD_PageNumberConfig(0);//ǰҳ
	LCD_PageDisplayTime(2);//ÿҳʾʱ(2*64+1)/120Լ1
	LCD_ScrollDisplayPage(14);//ҳ14+1				

	LCD_Grayscale(LCD_Grayscale85);
	LCD_GrayscaleCmd(ENABLE);
	LCD_ClearPage(LCD_Page_0);	//ҳ0ʾ
	
	LCD_SetDisplayCOM(LCD_PinSource0,LCD_COM_0,ENABLE);
	LCD_SetDisplayCOM(LCD_PinSource1,LCD_COM_1,ENABLE);
	LCD_SetDisplayCOM(LCD_PinSource2,LCD_COM_2,ENABLE);
	LCD_SetDisplayCOM(LCD_PinSource3,LCD_COM_3,ENABLE);
}

int main (void)
{
	LCD_GPIO_Config();
	LCD_Mode_Config();

	Display_number(1,4,Display_Page);
	Display_number(2,7,Display_Page);
	Display_number(3,9,Display_Page);
	Display_number(4,7,Display_Page);
	
	LCD_Cmd(ENABLE);			//ʹLCD	
	LCD_UpdataCmd(ENABLE);	//LCDʾ
	while(1)
	{

	}
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(u8* file, u32 line)
{
	/* User can add his own implementation to report the file name and line number,
	   ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
	printf("Wrong parameters value: file %s on line %d\r\n", file, line);
	/* Infinite loop */
	while (1)
	{
	}
}
#endif
