/******************************************************************************
  * @Example PT32x076_AES
  * @author  ӦÿŶ
  * @version V1.0.0
  * @date    2023/7/15
  * @brief   ֱԱӲAESAESļܽ/ܽͨڴӡϢ
  *          
  ******************************************************************************
  * @attention	Ϊ96001λֹͣλżУ
  *
	* ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣
  * ̼/ͻʹаıϢκ, * Pai-IC κֱӣ ӻ̷𺦸
  *
  * (C) Ȩ Pai-IC Microelectronics
  *
  *****************************************************************************/
	
#include "PT32x076.h"
#include "string.h"
#include "rijndael.h"

/**
* @brief ʱ
* @param 
* @retval 
*/
void Software_Delay(void)
{
	u8 i, j,x;
	for(i=0; i<200; i++)
		for(j=0; j<200; j++)
			for(x=0; x<20; x++);
}

/**
* @brief UARTĸ
* @param 
* @retval 
*/
void UART_GPIO_Config(void)
{
	/* UARTܽŵĸù */
	GPIO_DigitalRemapConfig(AFIOA, GPIO_Pin_2, AFIO_AF_2, ENABLE);	//PA2 TX
	GPIO_DigitalRemapConfig(AFIOA, GPIO_Pin_3, AFIO_AF_2, ENABLE);	//PA3 RX
}

/**
* @brief UARTĹģʽ
* @param 
* @retval 
*/
void UART_Mode_Config(void)
{
	UART_InitTypeDef  UART_InitStruct;
	
	/*ʼUART0*/
	UART_InitStruct.UART_BaudRate = 9600;
	UART_InitStruct.UART_DataLength = UART_DataLength_8;
	UART_InitStruct.UART_StopBitLength = UART_StopBitLength_1;
	UART_InitStruct.UART_ParityMode = UART_Parity_None;
	UART_InitStruct.UART_Receiver = UART_Receiver_Enable;
	UART_Init(UART0, &UART_InitStruct);
	/*ʹUART0*/
	UART_Cmd(UART0, ENABLE);
}

/**
* @brief UART
* @param 
* @retval 
*/
void UART_Driver(void)
{
	UART_GPIO_Config();
	UART_Mode_Config();
}

/**
* @brief AESģʽ
* @param 
* @retval 
*/
void AES_Driver(void)
{
	AES_InitTypeDef AES_InitType;
	AES_InitType.AES_OperatingMode = AES_Mode_Encryption;
	AES_InitType.AES_EncryptionMethod = AES_EncryptionMethodCBC;
	AES_InitType.AES_KeySize = AES_KeySize192;
	AES_Init(AES, &AES_InitType);
}

/**
* @brief 128u8ʽתΪu32ʽ
* @param datau8ʽµԭʼݣΪ128
* @param data_transu32ʽµת
* @retval 
*/
void AES_lenth128_u8transu32(u8 data[16],u32 data_trans[4])
{
	union un
	{
		u8 input[16];
		u32 output[4];
	}trans;
	memcpy(trans.input,data,16);
	memcpy(data_trans,trans.output,16);
}

/**
* @brief 128u32ʽתΪu8ʽ
* @param datau32ʽµԭʼݣΪ128
* @param data_transu8ʽµת
* @retval 
*/
void AES_lenth128_u32transu8(u32 data[4],u8 data_trans[16])
{
	union un
	{
		u8 input[16];
		u32 output[4];
	}trans;
	memcpy(trans.output,data,16);
	memcpy(data_trans,trans.output,16);
}

/**
* @brief 192u8ʽתΪu32ʽ
* @param datau8ʽµԭʼݣΪ192
* @param data_transu32ʽµת
* @retval 
*/
void AES_lenth192_u8transu32(u8 data[24],u32 data_trans[6])
{
	union un
	{
		u8 input[24];
		u32 output[6];
	}trans;
	memcpy(trans.input,data,24);
	memcpy(data_trans,trans.output,24);
}

/**
* @brief ӲAES/
* @param 
* @retval 
*/
void AES_cbc_192_hardware(void)
{
	//u8ʽµ
	u8 buf[16] = { 0x00, 0x11, 0x22, 0x33, 0x44, 0x55, 0x66, 0x77,
										0x88, 0x99, 0xaa, 0xbb, 0xcc, 0xdd, 0xee, 0xff };
	//u8ʽµԿ
	u8 encrypt_key[24] = { 0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07,
										0x08, 0x09, 0x0a, 0x0b, 0x0c, 0x0d, 0x0e, 0x0f,
										0x10, 0x11, 0x12, 0x13, 0x14, 0x15, 0x16, 0x17 };
	//u8ʽµĳʼ
	u8 iv[16] = { 0x01, 0x10, 0x02, 0x20, 0x03, 0x30, 0x04, 0x40,
										0x05, 0x50, 0x06, 0x60, 0x07, 0x70, 0x08, 0x80 };
	u8 encrypt_result[16] = {0};
	u8 decrypt_result[16] = {0};
	//u32ʽ									
	u32 buf_word[4] = {0};									//u32ʽµ
	u32 encrypt_key_word[6] = {0};					//u32ʽµԿ
	u32 encrypt_keyexpand_word[6] = {0};		//u32ʽµԿ
	u32 iv_word[4] = {0};										//u32ʽµĳʼ
	u32 encrypt_result_word[4] = {0};				//u32ʽµļģܽ
	u32 decrypt_result_word[4] = {0};				//u32ʽµĽģܽ
	
	//ģʽ
	AES_lenth192_u8transu32(encrypt_key,encrypt_key_word);//Ϊu32ʽ
	AES_SetKey(AES,encrypt_key_word,AES_KeySize192);//ԿдĴ
	AES_lenth128_u8transu32(iv,iv_word);//Ϊu32ʽ
	AES_InitializationVectorInput(AES,iv_word);//ʼдĴ
	AES_lenth128_u8transu32(buf,buf_word);//Ϊu32ʽ	
	AES_DataInput(AES,buf_word);//дĴ
	AES_StartComputation(AES);//ʼ
	while(AES_GetFlagStatus(AES,AES_FLAG_CCF) != SET);//ȴ
	AES_GetDataOutput(AES,encrypt_result_word);//ȡ128λ
	AES_lenth128_u32transu8(encrypt_result_word,encrypt_result);//ܽu32תΪu8ʽ
	printf("ӲAESܽ");
	aes_dump("data", encrypt_result, sizeof(encrypt_result));
	
	//ģʽ
	AES_OperatingMode(AES,AES_Mode_Encryption);//ѡģʽ
	AES_KeyExpansion(AES);//ʹԿչ
	AES_KeySizeConfig(AES,AES_KeySize192);//ѡԿ
	AES_SetKey(AES,encrypt_key_word,AES_KeySize192);//u32ʽԿдĴ
	AES_StartComputation(AES);//ʼԿչ
	while(AES_GetFlagStatus(AES,AES_FLAG_CCF) != SET);//ȴ
	AES_GetKey(AES,encrypt_keyexpand_word,AES_KeySize192);//ȡԿ
	
	AES_OperatingMode(AES,AES_Mode_Decrypt);//ѡģʽ
	AES_EncryptionMethodConfig(AES,AES_EncryptionMethodCBC);//ѡܸʽ
	AES_KeySizeConfig(AES,AES_KeySize192);//ѡԿ
	AES_SetKey(AES,encrypt_keyexpand_word,AES_KeySize192);//дԿ
	AES_InitializationVectorInput(AES,iv_word);//дʼ
	AES_DataInput(AES,encrypt_result_word);//дܺ
	AES_StartComputation(AES);//ʼ
	while(AES_GetFlagStatus(AES,AES_FLAG_CCF) != SET);//ȴ
	AES_GetDataOutput(AES,decrypt_result_word);//ȡ128λ
	AES_lenth128_u32transu8(decrypt_result_word,decrypt_result);//ܽu32תΪu8ʽ
	printf("ӲAESܽ");
	aes_dump("data", decrypt_result, sizeof(decrypt_result));
}

/**
* @brief AES/
* @param 
* @retval 
*/
void AES_cbc_192_software(void)
{
	aes_cypher_192_test();
}

int main (void)
{
	UART_Driver();
	AES_Driver();
	printf("/ӲAESԶԱ\r\n");
	AES_cbc_192_hardware();
	AES_cbc_192_software();
	while(1)
	{
		
	}
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(u8* file, u32 line)
{
	/* User can add his own implementation to report the file name and line number,
	   ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
	printf("Wrong parameters value: file %s on line %d\r\n", file, line);
	/* Infinite loop */
	while (1)
	{
	}
}
#endif
